tutorial "translateGerCampaign_T"
{
	consts
	{
		raceUSA = 1;
		raceRUS = 2;
		raceGER = 3;
	}
	
    int iMissionToLoad;

	state Initialize;
	state StartFirstMission;
    state LoadFirstMission;
    state LoadMission;
	state EndGame;
	state Nothing;

	//----------------------------------------------------------------------------------------- 	
	state Initialize
	{
		CreateGamePlayer(0,raceGER,playerLocal,null);

		RegisterMission(1,"!Tutorial_01","Ger\\Missions\\Ger_T_1","translateGer_T_1 ", 0, 0, 0, 0, 0, 0);
 
		EnableGameFeature
			(
			lockAllianceDialog |
			lockGiveMoneyDialog |
			lockGiveUnitsDialog |
//			lockShowToolbar |
//			lockToolbarMap |
//			lockToolbarPanel |
			lockToolbarLevelName |
//			lockToolbarSwitchMode |
			lockToolbarAlliance |
			lockToolbarGiveMoney |
//			lockToolbarObjectives |
//			lockToolbarMenu |
//			lockToolbarMoney |
			lockDisplayToolbarLevelName |
//			lockDisplayToolbarMoney |
//			lockCreateBuildPanel |
//			lockCreatePanel |
//			lockCreateMap |
			0, true);

		ShowMissionVideoDialog(null,null, true);

        iMissionToLoad = 1;

		return StartFirstMission,1;
	}

	//----------------------------------------------------------------------------------------- 
    state StartFirstMission
    {
        ForceKeepBitmapAfterStatistic();

        return LoadFirstMission,0;
    }
	
	state LoadFirstMission
    {
        LoadMission(0,iMissionToLoad);
		SetAvailableWorlds(1);
		SetActivePlayerAndWorld(0,0);

		return Nothing, 0;
    }

	//----------------------------------------------------------------------------------------- 
	state LoadMission
	{
        LoadMission(0,iMissionToLoad);

		return Nothing,0;
	}

	//----------------------------------------------------------------------------------------- 

	state EndGame
	{
		EndGame("");

        return Nothing,0;
	}

    state Nothing
    {
        return Nothing,0;
    }

	//----------------------------------------------------------------------------------------- 
    event EndMission(int iMission, int iResult)
    {
      if(iResult==true)
        {
			EnableCampaign("USA\\CampaignGer_T2Disabled");
			EnableCampaign("GER\\CampaignGer_AlphaMapDisabled");
         	EnableCampaign("GER\\CampaignGer_1Disabled");
			EnableCampaign("RUS\\CampaignRus_1Disabled");
			EnableCampaign("USA\\CampaignUsa_1Disabled");
			state EndGame;
        }
        else
        {
			ForceKeepBitmapAfterStatistic();
        
            state LoadMission;
        }			
    }

	//----------------------------------------------------------------------------------------- 
	enum difficultyLevel
    {
        "translateSelectCampaignDifficultyTraining",
        multi:
        ""
    }

	//----------------------------------------------------------------------------------------- 
    command Initialize()
    {
        difficultyLevel=0;

		return true;
    }

	//----------------------------------------------------------------------------------------- 
    command DifficultyLevel(int nLevel) button difficultyLevel
    {
		return true;
    }
}