#include "..\..\Translates.ech"
mission "translateGermany_Alpha"
{
#define USE_TRACE
#include "..\..\Trace.ech"
#include "..\..\Common.ech"
    consts
    {
	//Artefact
	aStrongholdRUS=0;
    aStrongholdGER=1;
	//aNazwa
	//Goals
	gRecoHERO = 0;
	gRecoEnemy = 1;
	gCompletPrestige = 2;
	gStronghold = 3;
	gHeroLive = 4;
    }
    
    player pPlayer;
	player pPlayer2;
    player pEnemy;

	unitex uHero;
	unitex uSupply;
	human hHero;

	platoon pPlatoon1;
	platoon pPlatoon2;
    platoon pPlatoon3;
	platoon pPlatoon4;
	platoon pPlatoon5;
    platoon pPlatoon6;
    platoon pPlatoon7;
	platoon pPlatoon8;
    platoon pPlatoon9;
    platoon pPlatoon10;

	int bTimerSetConsole;
	int iTimerSetConsole;

	int bNalot;
	int iNalot;

	int bDesant;
	int iDesant;

	int bMapSign1;
	int iMapSign1;
	int bMapSign2;
	int iMapSign2;
	int bMapSign3;
	int iMapSign3;
	int bMapSign4;
	int iMapSign4;

	int m_nAirStrikeID;
	int m_nAirStrikeID2;
	int m_nAirStrikeID3;
	int iArtillery;

	int bInformationEnemyRecoHERO;
	int bInformationEnemyRecoEnemy;
	int bInformationEnemyRecoEnemyEND;
	int bInformationEnemyRecoHEROEND;
	int bInformationFirstSupport;
	int bInformationPARACHUTE;
	int bInformationMoney;
	int bInformationMoneyB;
	int bInformationStronghold;
	int bInformationMineA;
	int bInformationMineB;
	int bDisabledCamera;
    int bDisabledCamera2;
	int bDisabledCameraDesant;
	int bCreateSupply;
    state Initialize;
	state ShowBriefing;
	state Mission;
    state Nothing;

function int CheckSupplyLive()
{
    if (bCreateSupply && (uSupply==null || !uSupply.IsLive()))
    {
		uSupply = pPlayer.CreateUnit(GetPointX(56), GetPointY(56), 0, "GER_SUPL1");
		//uSupply = GetUnit(GetPointX(56), GetPointY(56), 0);
		if(uSupply!=null)
		{
			uSupply.CommandMove(GetPointX(75), GetPointY(75), 0);
	        AddWorldMapSign(GetPointX(56), GetPointY(56), 0, 5, 200);
		}
    }

    return true;

}
	//----------------------------------------------------------------------------------------- 
	state Initialize //definiuje wszystkie zmienne
    {
	//---------- Players --------------------------
    pPlayer=GetPlayer(0); 
	pEnemy=GetPlayer(1);
	pPlayer2=GetPlayer(4);

	//---------- AI -------------------------------
	pPlayer.EnableStatistics(true);
	pEnemy.EnableStatistics(true);
	pPlayer2.EnableStatistics(false);

	//pPlayer.EnableAIFeatures(aiEnabled,false);
	pPlayer2.EnableAIFeatures(aiEnabled,false);
        pPlayer2.EnableAIFeatures2(ai2ChooseEnemy, false);
	pEnemy.EnableAIFeatures(aiEnabled,false);
        //pEnemy.EnableAIFeatures2(ai2ChooseEnemy, false);

	pPlayer2.EnableAIFeatures(aiControlOffense,false);
	pPlayer2.EnableAIFeatures(aiRejectAlliance,false);
// ustawienie neutralnoci playera przy blokowaniu unitw
	pPlayer2.SetNeutral(pEnemy);
	pEnemy.SetNeutral(pPlayer2);

	pPlayer2.SetNeutral(pPlayer);
    pPlayer.SetNeutral(pPlayer2);


	pPlayer.SetAlly(pPlayer2);

    //----------- Units ---------------------------	
    uHero=GetUnit(GetPointX(0),GetPointY(0),0); // (marker())
	hHero = uHero.GetHuman(0);
	hHero.SetHumanName("translateHERO_GER1SQUAD");
	hHero.SetIsSpecialHuman(true);
	uSupply = GetUnit(GetPointX(75), GetPointY(75), 0);

	//----------- Platoon -------------------------

	//----------- Create Artefactr ----------------
	CreateArtefact("ART_ZNAKRUS",GetPointX(3),GetPointY(3),0,aStrongholdRUS,artefactSpecialAI);
	//----------- Register Goal -------------------
	RegisterGoal(gRecoHERO,"translateGer_Aplhamap_Goal_RecoHERO");
	RegisterGoal(gCompletPrestige,"translateGer_Aplhamap_Goal_CompletPrestige");
	RegisterGoal(gStronghold,"translateGer_Aplhamap_Goal_Stronghold");
	RegisterGoal(gHeroLive,"translateGer_Aplhamap_Goal_HeroLive");

	//----------- Artilery or AirStrike -----------

   if(GetDifficultyLevel()==0)
    {
        //m_nAirStrikeID = pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 6);
        //m_nAirStrikeID2 = pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 3);
        //m_nAirStrikeID3 = pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 5);
        //iArtillery = pPlayer.AddArtileryOrAirStrike(null,"GER_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,5);

    }
    
	if(GetDifficultyLevel()==1)
	{
        /*iAirStrikeID = pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 0);
        iAirStrikeID2 = pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 0);
        iAirStrikeID3 = pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 0);
        iArtillery = pPlayer.AddArtileryOrAirStrike(null,"GER_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,0;*/

		pEnemy.CreateUnit( 108,  48, 0, "RUS_IS3");
	}
	
	if(GetDifficultyLevel()==2)
    {
        /*iAirStrikeID = pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 0);
        iAirStrikeID2 = pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 0);
        iAirStrikeID3 = pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 0);
        iArtillery = pPlayer.AddArtileryOrAirStrike(null,"GER_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,0;*/
		pEnemy.CreateUnit( 108,  48, 0, "RUS_IS3");
		pEnemy.CreateUnit( 71,  102, 0, "RUS_IS3");
		pEnemy.CreateUnit( 107,  85, 0, "RUS_IS3");
    }

	//----------- Object Template -----------------

	//----------- Enable Command -----------------
	// Budynki nie maj autodestrukcji
	pPlayer.EnableCommand(commandAutodestruction,false);  
    
	//----------- Time ----------------------------
	//Ustawienie czasu w grze
	SetTime(100);



	//----------- Timer ---------------------------
	SetTimer(0,50);		// 2.5 s
    SetTimer(2, 1200);     // 1min
	//----------- Console Text --------------------
	// Zdefionowanie ile linijek bdzie do wywietlania console_textw liczonych od gry
	AddConsoleTextDisplay(0,0,100,SS_CENTER);
	AddConsoleTextDisplay(1,0,100,SS_CENTER);
	AddConsoleTextDisplay(2,0,100,SS_CENTER);

	//----------- Camera --------------------------
	// Przywoanie kamery i ustawienie jest nad starting pointem
	CallCamera();
	pPlayer.LookAt(pPlayer.GetStartingPointX(),pPlayer.GetStartingPointY(),7,0,30,0);

	SelectBuildPanelTab(4);

	//----------- Variables -----------------------
	bTimerSetConsole=false;
	iTimerSetConsole=0;

	bNalot=false;
	bDesant=false;

	bMapSign1=false;
	iMapSign1=10;
	bMapSign2=false;
	iMapSign2=10;
	bMapSign3=false;
	iMapSign3=10;
	bMapSign4=false;
	iMapSign4=10;

	bInformationPARACHUTE=false;
	bInformationEnemyRecoHERO=false;
	bInformationEnemyRecoHEROEND=false;
	bInformationEnemyRecoEnemy=false;
	bInformationEnemyRecoEnemyEND=false;
	bInformationFirstSupport=false;
	bInformationMoney=false;
	bInformationMoneyB=false;
	bInformationStronghold=false;
	bInformationMineA=false;
	bInformationMineB=false;
	bDisabledCamera=false;
	bDisabledCamera2=false;
	bDisabledCameraDesant=false;
	bCreateSupply = false;
    SetHelpMode(true);
    return ShowBriefing,50;	// Przejcie do state ShowBriefing za 2 sekundy
    }

	//-----------------------------------------------------------------------------------------
    // State pocztkowy
	state ShowBriefing
    {
		EnableGoal(gRecoHERO,true);
		EnableGoal(gCompletPrestige,true);
		EnableGoal(gStronghold,true); 
		EnableGoal(gHeroLive,true); 

        AddBriefing(SND_GA_BRIEFING_START,TRL_GA_BRIEFING_START);

		AddWorldMapSign(GetPointX(1),GetPointY(1),0,4,65000); //4 numer mapsign
		AddWorldMapSign(GetPointX(3),GetPointY(3),0,1,65000);

		Rain(GetRight()/2,GetBottom()/2,256,200,3200,150,Rand(6));//256 0dleglosc od punktu,100 jak dlugo zaczyna,3200jak dlugo pada,150jak dlugo konczy rand losowa INTESYWNOSC1-6

        return Mission,200; //200 odstep po briefingu
    }

	//-----------------------------------------------------------------------------------------
    state Mission //wszystkie definicje zachowan w misji
    {
		uHero = GetUnitExRef(hHero.GetParent());//GetParent zwraca typ unit, GetUnitExRef konwertuje typ unit do unitex
		if(bInformationEnemyRecoHERO==false && (uHero != null) && uHero.DistanceTo(GetPointX(1),GetPointY(1))<4)
		{
			bInformationEnemyRecoHERO=true;

			SetGoalState(gRecoHERO,goalAchieved);

            PlayWave("Fanfare.wav");
            PlayWave(SND_GA_CON_RECOHERO1,20);
        
			SetConsoleText(1,TRL_GA_CON_RECOHERO1);
			SetConsoleText(2,TRL_GA_CON_RECOHERO2);
			SetConsoleText(3,"");
			bTimerSetConsole=true;
			iTimerSetConsole=5;

			RemoveWorldMapSign(GetPointX(1),GetPointY(1),0);

			pPlayer.MakeBombingAttack(GetPointX(2),GetPointY(2),"GER_BOMBER","GER_BOMB",6,5,0,0,-1);
			//atak bombowcow na marker2
			pPlayer.MakeBombingAttack(GetPointX(72),GetPointY(72),"GER_BOMBER","GER_BOMB",6,5,0,0,-1);
			pPlayer.MakeBombingAttack(GetPointX(73),GetPointY(73),"GER_BOMBER","GER_BOMB",6,5,0,0,-1);
			pPlayer.MakeBombingAttack(GetPointX(74),GetPointY(74),"GER_BOMBER","GER_BOMB",6,5,0,0,-1);

			bNalot=true;
			iNalot=3;

			//AddWorldMapSign(GetPointX(2),GetPointY(2),0,3,65000);
			
			return Mission,40;
		}

		if(bDisabledCamera==true)//powrt kamery i przekazanie jednostek po nalocie
		{
			bDisabledCamera=false;

			EnableCameraMovement(true);
            EnableInterface(true);

			return Mission,200;
		}

        
		if(bInformationEnemyRecoHEROEND==false//powrt kamery i przekazanie jednostek po nalocie
			&& bInformationEnemyRecoHERO==true
			&& iNalot==0)
		{
			bInformationEnemyRecoHEROEND=true;

			pPlayer.LookAt(GetPointX(0),GetPointY(0),24,0,30,0);//kamera  na marker0

            
			pPlayer2.GiveAllUnitsTo(pPlayer);
			bCreateSupply = true;

            PlayWave("Fanfare.wav");
            PlayWave(SND_GA_CON_GIVENEWUNITS,20);
        
			SetConsoleText(1,TRL_GA_CON_GIVENEWUNITS);
			SetConsoleText(2,"");
			SetConsoleText(3,"");
			bTimerSetConsole=true;
			iTimerSetConsole=5;
				
			AddWorldMapSign(GetPointX(5),GetPointY(5),0,4,65000);
			AddWorldMapSign(GetPointX(6),GetPointY(6),0,4,65000);

			return Mission,300;
		}

        if(bInformationPARACHUTE==false && bInformationEnemyRecoHEROEND==true)
		{
			bInformationPARACHUTE=true;


			pPlayer.MakeBombingAttack(GetPointX(68),GetPointY(68),"GER_PARATRANSP","GER_PARACHUTESQUAD",5,5,0,0,-1);
			pPlayer.MakeBombingAttack(GetPointX(69),GetPointY(69),"GER_PARATRANSP","GER_PARACHUTESQUAD",5,5,0,0,-1);
			pPlayer.MakeBombingAttack(GetPointX(70),GetPointY(70),"GER_PARATRANSP","GER_PARACHUTESQUAD",5,5,0,0,-1);
			pPlayer.MakeBombingAttack(GetPointX(71),GetPointY(71),"GER_PARATRANSP","GER_PARACHUTESQUAD",5,5,0,0,-1);
			bDesant=true;
			iDesant=2;
	
			return Mission,250;//przy consoletext250, przy briefing50
		}
		

		if(bInformationFirstSupport==false//definiuje posilki dla gracza m 8
			&& IsUnitNearPoint(GetPointX(38),GetPointY(38),0,5,pPlayer.GetIFF()))//po dotarciu dowolnego unita do m4
		{
			bInformationFirstSupport=true;

			pPlayer.CreateUnit(GetPointX(8)+0,GetPointY(8)+0,0,"GER_BAZOOKASQUAD");
			pPlayer.CreateUnit(GetPointX(8)+1,GetPointY(8)+0,0,"GER_BAZOOKASQUAD");
			pPlayer.CreateUnit(GetPointX(8)-1,GetPointY(8)+0,0,"GER_BAZOOKASQUAD");
			pPlayer.CreateUnit(GetPointX(8)+0,GetPointY(8)+1,0,"GER_BAZOOKASQUAD");
			pPlayer.CreateUnit(GetPointX(8)+1,GetPointY(8)+1,0,"GER_SOLDIERSQUAD");
			pPlayer.CreateUnit(GetPointX(8)-1,GetPointY(8)+1,0,"GER_SOLDIERSQUAD");
			pPlayer.CreateUnit(GetPointX(8)+0,GetPointY(8)-1,0,"GER_SOLDIERSQUAD");
            pPlayer.CreateUnit(GetPointX(8)-1,GetPointY(8)-0,0,"GER_SOLDIERSQUAD");
			
		    AddWorldMapSign(GetPointX(8),GetPointY(8),0,2,65000); //2 numer mapsign
		    bMapSign1=true;
            
            PlayWave("Fanfare.wav");
            PlayWave(SND_GA_CON_GIVENEWUNITS,20);
        
			SetConsoleText(1,TRL_GA_CON_GIVENEWUNITS);
			SetConsoleText(2,"");
			SetConsoleText(3,"");
			bTimerSetConsole=true;
			iTimerSetConsole=5;

//tworze jednostki wroga na mapie w punkcie m9
			pEnemy.CreateUnit(GetPointX(9)+0,GetPointY(9)+0,0,"RUS_T26");
			pEnemy.CreateUnit(GetPointX(9)+1,GetPointY(9)+0,0,"RUS_T26");
			pEnemy.CreateUnit(GetPointX(9)-1,GetPointY(9)+0,0,"RUS_T26");
			pEnemy.CreateUnit(GetPointX(9)+0,GetPointY(9)+1,0,"RUS_T26");
		
//skladam z nich pluton pomiedzy m 10 i m 11
			pPlatoon1=pEnemy.CreatePlatoon(null,GetPointX(11),GetPointY(11),GetPointX(10),GetPointY(10),0);

			pPlatoon1.BeginQuickRecord();
			pPlatoon1.CommandMove(GetPointX(12),GetPointY(12),0);//trasa przejazdu plutonu wroga
			pPlatoon1.CommandMove(GetPointX(13),GetPointY(13),0);
			pPlatoon1.CommandMove(GetPointX(14),GetPointY(14),0);
			pPlatoon1.CommandMove(GetPointX(15),GetPointY(15),0);
			pPlatoon1.CommandMove(GetPointX(16),GetPointY(16),0);
			pPlatoon1.CommandMove(GetPointX(17),GetPointY(17),0);
			pPlatoon1.CommandMove(GetPointX(18),GetPointY(18),0);
			pPlatoon1.CommandMove(GetPointX(0),GetPointY(0),0);
			pPlatoon1.EndQuickRecord();

			return Mission,50;
		}

		/////////////////////////////////////////
		//robimy nalot rozpoznawczy na M66
		if(bInformationEnemyRecoEnemy==false 
			&& bInformationFirstSupport==true
			&& pPlatoon1.DistanceTo(GetPointX(66),GetPointY(66))<16)
		{
			bInformationEnemyRecoEnemy=true;

            PlayWave("Fanfare.wav");
            PlayWave(SND_GA_CON_RECONENEMY,20);
        
			SetConsoleText(1,TRL_GA_CON_RECONENEMY);
			SetConsoleText(2,"");
			SetConsoleText(3,"");
			bTimerSetConsole=true;
			iTimerSetConsole=5;

			pPlayer.MakeBombingAttack(GetPointX(66),GetPointY(66),"GER_RECON","RECON_GER",0,3,3,0,-1);
		       
			return Mission,150;
		}

		if(bDisabledCamera2==true)//powrt kamery i przekazanie jednostek po nalocie
		{
			bDisabledCamera2=false;
			return Mission,600;
		}

		if(bInformationEnemyRecoEnemyEND==false//powrt kamery na posilki
			&& bInformationEnemyRecoEnemy==true)
		{
			bInformationEnemyRecoEnemyEND=true;

			pPlayer.LookAt(GetPointX(8),GetPointY(8),24,0,30,0);//kamera  na marker8

            EnableCameraMovement(true);
            EnableInterface(true);

			SetConsoleText(1,"");
			SetConsoleText(2,"");
			SetConsoleText(3,"");
			bTimerSetConsole=true;
			iTimerSetConsole=5;
				
			return Mission,50;
		}


		if(bInformationMoneyB==false//sprawdzam czy wydobyl z kopaln 10 000 i daje posiki
			&& pPlayer.GetMoney()>=10000)
		{
			bInformationMoneyB=true;

			SetConsoleText(1,"");
			SetConsoleText(2,"");
			SetConsoleText(3,"");
			bTimerSetConsole=true;
			iTimerSetConsole=5;

			pPlayer.CreateUnit(GetPointX(67)-1,GetPointY(67)+0,0,"GER_D5DE");
			pPlayer.CreateUnit(GetPointX(67)-1,GetPointY(67)+1,0,"GER_D5DE");
			pPlayer.CreateUnit(GetPointX(67)-0,GetPointY(67)+0,0,"GER_D5DE");
			pPlayer.CreateUnit(GetPointX(67)-0,GetPointY(67)+1,0,"GER_D5DE");
			pPlayer.CreateUnit(GetPointX(67)+1,GetPointY(67)+0,0,"GER_D5DE");
			pPlayer.CreateUnit(GetPointX(67)+1,GetPointY(67)+1,0,"GER_D5DE");

            PlayWave("Fanfare.wav");
            PlayWave(SND_GA_CON_GIVENEWUNITS,20);
        
			SetConsoleText(1,TRL_GA_CON_GIVENEWUNITS);
			SetConsoleText(2,"");
			SetConsoleText(3,"");
			bTimerSetConsole=true;
			iTimerSetConsole=5;

		    AddWorldMapSign(GetPointX(67),GetPointY(67),0,2,65000); //2 numer mapsign
		    bMapSign3=true;
			return Mission,400;//przy consoletext250, przy briefing50
		}

        
		if(bDisabledCameraDesant==true)
		{
			bDisabledCameraDesant=false;

			EnableCameraMovement(true);
            EnableInterface(true);

			return Mission,200;

		}
		/////////////////////////////////////////

		if(bInformationMoney==false//sprawdzam czy wydobyl z kopaln 5000
			&& pPlayer.GetMoney()>=5000)
		{
			bInformationMoney=true;

			SetGoalState(gCompletPrestige,goalAchieved);

            PlayWave("Fanfare.wav");
            PlayWave(SND_GA_CON_COMPLETEPRESTIGE1,20);
        
			SetConsoleText(1,TRL_GA_CON_COMPLETEPRESTIGE1);
			SetConsoleText(2,TRL_GA_CON_COMPLETEPRESTIGE2);
			SetConsoleText(3,"");
			bTimerSetConsole=true;
			iTimerSetConsole=5;

			pPlayer.CreateUnit(GetPointX(56)+0,GetPointY(56)+0,0,"GER_TIGER");
			pPlayer.CreateUnit(GetPointX(56)+1,GetPointY(56)+0,0,"GER_250_9");
			pPlayer.CreateUnit(GetPointX(56)-1,GetPointY(56)+0,0,"GER_TIGER");
			pPlayer.CreateUnit(GetPointX(56)+0,GetPointY(56)+1,0,"GER_TIGER");
			pPlayer.CreateUnit(GetPointX(56)+1,GetPointY(56)+1,0,"GER_TIGER");
			pPlayer.CreateUnit(GetPointX(56)-1,GetPointY(56)+1,0,"GER_250_9");
			pPlayer.CreateUnit(GetPointX(56)+0,GetPointY(56)-1,0,"GER_250_9");
			pPlayer.CreateUnit(GetPointX(56)-1,GetPointY(56)-1,0,"GER_250_9");

		    AddWorldMapSign(GetPointX(56),GetPointY(56),0,2,65000); //2 numer mapsign
		    bMapSign2=true;

			pEnemy.CreateUnit(GetPointX(52)+0,GetPointY(52)+0,0,"RUS_BA20");
			pEnemy.CreateUnit(GetPointX(52)+1,GetPointY(52)+0,0,"RUS_BA20");
			pEnemy.CreateUnit(GetPointX(52)-1,GetPointY(52)+0,0,"RUS_T26");
			pEnemy.CreateUnit(GetPointX(52)-1,GetPointY(52)+1,0,"RUS_T3485");
			pPlatoon7=pEnemy.CreatePlatoon(null,GetPointX(53),GetPointY(53),GetPointX(54),GetPointY(54),0);

			pPlatoon7.BeginQuickRecord();
			pPlatoon7.CommandMove(GetPointX(55),GetPointY(55),0);//trasa przejazdu plutonu wroga
			pPlatoon7.EndQuickRecord();

			pEnemy.CreateUnit(GetPointX(57)+0,GetPointY(57)+0,0,"RUS_BA20");
			pEnemy.CreateUnit(GetPointX(57)+1,GetPointY(57)+0,0,"RUS_BA20");
			pEnemy.CreateUnit(GetPointX(57)-1,GetPointY(57)+0,0,"RUS_T26");
			//pEnemy.CreateUnit(GetPointX(57)+0,GetPointY(57)+1,0,"RUS_T26");
			pPlatoon8=pEnemy.CreatePlatoon(null,GetPointX(58),GetPointY(58),GetPointX(59),GetPointY(59),0);

			pPlatoon8.BeginQuickRecord();
			pPlatoon8.CommandMove(GetPointX(13),GetPointY(13),0);//trasa przejazdu plutonu wroga
			pPlatoon8.CommandMove(GetPointX(14),GetPointY(14),0);
			pPlatoon8.CommandMove(GetPointX(15),GetPointY(15),0);
			pPlatoon8.CommandMove(GetPointX(16),GetPointY(16),0);
			pPlatoon8.EndQuickRecord();

			pEnemy.CreateUnit(GetPointX(16)+0,GetPointY(16)+0,0,"RUS_T26");
			pEnemy.CreateUnit(GetPointX(16)+1,GetPointY(16)+0,0,"RUS_T26");
			//pEnemy.CreateUnit(GetPointX(16)-1,GetPointY(16)+0,0,"RUS_T26");
			//pEnemy.CreateUnit(GetPointX(16)-1,GetPointY(16)+1,0,"RUS_T3485");
			pPlatoon9=pEnemy.CreatePlatoon(null,GetPointX(60),GetPointY(60),GetPointX(61),GetPointY(61),0);

			pPlatoon9.BeginQuickRecord();
			pPlatoon9.CommandMove(GetPointX(2),GetPointY(2),0);//trasa przejazdu plutonu wroga
			pPlatoon9.CommandMove(GetPointX(1),GetPointY(1),0);
			pPlatoon9.CommandMove(GetPointX(17),GetPointY(17),0);
			pPlatoon9.CommandMove(GetPointX(18),GetPointY(18),0);
			pPlatoon9.CommandMove(GetPointX(56),GetPointY(56),0);
			pPlatoon9.EndQuickRecord();

			pEnemy.CreateUnit(GetPointX(62)+0,GetPointY(62)+0,0,"RUS_T26");
			pEnemy.CreateUnit(GetPointX(62)+1,GetPointY(62)+0,0,"RUS_T26");
			pEnemy.CreateUnit(GetPointX(62)+0,GetPointY(62)+1,0,"RUS_T3485");
			//pEnemy.CreateUnit(GetPointX(62)-1,GetPointY(62)+1,0,"RUS_T3485");
			pPlatoon10=pEnemy.CreatePlatoon(null,GetPointX(63),GetPointY(63),GetPointX(64),GetPointY(64),0);

			pPlatoon10.BeginQuickRecord();
			pPlatoon10.CommandMove(GetPointX(65),GetPointY(65),0);//trasa przejazdu plutonu wroga
			pPlatoon10.EndQuickRecord();

			pPlayer.MakeBombingAttack(GetPointX(3),GetPointY(3),"GER_RECON","RECON_GER",0,3,3,0,-1);
			pPlayer.LookAt(GetPointX(55),GetPointY(55),24,0,30,0);

        m_nAirStrikeID = pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 4);
        m_nAirStrikeID2 = pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 2);
        m_nAirStrikeID3 = pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 5);
        iArtillery = pPlayer.AddArtileryOrAirStrike(null,"GER_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,1);

			return Mission,400;//przy consoletext250, przy briefing50
		}


		//TRACE2("bInformationStronghold==", bInformationStronghold);
    if (bInformationStronghold==false &&
        !IsUnitNearPoint(GetPointX(3), GetPointY(3), 0, 12, pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(3), GetPointY(3), 0, 4, pPlayer.GetIFF()))
		{
			bInformationStronghold=true;

			SetGoalState(gStronghold,goalAchieved);
			SetGoalState(gHeroLive,goalAchieved);
			RemoveArtefact(GetPointX(3),GetPointY(3),0);

			CreateArtefact("ART_ZNAKGER",GetPointX(3),GetPointY(3),0,aStrongholdGER,artefactSpecialAI);

			RemoveWorldMapSign(GetPointX(3),GetPointY(3),0);

			AddBriefing(SND_GA_BRIEFING_VICTORY,TRL_GA_BRIEFING_VICTORY);

			EndMission(true);

			return Nothing,500;
		}

		if(bInformationMineA==false//wstawiam mapsign po dotarciu Playera do m5
			&& IsUnitNearPoint(GetPointX(5),GetPointY(5),0,2,pPlayer.GetIFF()))
		{
			bInformationMineA=true;

			pEnemy.CreateUnit(GetPointX(19)+0,GetPointY(19)+0,0,"RUS_BA20");
			pEnemy.CreateUnit(GetPointX(19)+1,GetPointY(19)+0,0,"RUS_T26");
			//pEnemy.CreateUnit(GetPointX(19)-1,GetPointY(19)+0,0,"RUS_T26");
			pEnemy.CreateUnit(GetPointX(19)+0,GetPointY(19)+1,0,"RUS_SOLDIERSQUAD");
		
   //skladam z nich pluton pomiedzy m 10 i m 11
			pPlatoon2=pEnemy.CreatePlatoon(null,GetPointX(21),GetPointY(21),GetPointX(20),GetPointY(20),0);
					
			pPlatoon2.BeginQuickRecord();
			pPlatoon2.CommandMove(GetPointX(22),GetPointY(22),0);//trasa przejazdu plutonu wroga
			pPlatoon2.CommandMove(GetPointX(23),GetPointY(23),0);
			pPlatoon2.CommandMove(GetPointX(25),GetPointY(25),0);
			pPlatoon2.EndQuickRecord();

			pEnemy.CreateUnit(GetPointX(31)+0,GetPointY(31)+0,0,"RUS_BA20");
			pEnemy.CreateUnit(GetPointX(31)+1,GetPointY(31)+0,0,"RUS_T26");
			//pEnemy.CreateUnit(GetPointX(31)-1,GetPointY(31)+0,0,"RUS_BA20");
			//pEnemy.CreateUnit(GetPointX(31)+0,GetPointY(31)+1,0,"RUS_T3485");
			pPlatoon4=pEnemy.CreatePlatoon(null,GetPointX(32),GetPointY(32),GetPointX(33),GetPointY(33),0);

			pPlatoon4.BeginQuickRecord();
			pPlatoon4.CommandMove(GetPointX(34),GetPointY(34),0);//trasa przejazdu plutonu wroga
			pPlatoon4.CommandMove(GetPointX(35),GetPointY(35),0);
			pPlatoon4.CommandMove(GetPointX(36),GetPointY(36),0);
			pPlatoon4.CommandMove(GetPointX(22),GetPointY(22),0);
			pPlatoon4.CommandMove(GetPointX(37),GetPointY(37),0);
			pPlatoon4.CommandMove(GetPointX(38),GetPointY(38),0);
			pPlatoon4.EndQuickRecord();

			pEnemy.CreateUnit(GetPointX(39)+0,GetPointY(39)+0,0,"RUS_SOLDIERSQUAD");
			pEnemy.CreateUnit(GetPointX(39)+1,GetPointY(39)+0,0,"RUS_T26");
			pEnemy.CreateUnit(GetPointX(39)-1,GetPointY(39)+0,0,"RUS_T26");
			//pEnemy.CreateUnit(GetPointX(39)+0,GetPointY(39)+1,0,"RUS_T3485");
			pPlatoon5=pEnemy.CreatePlatoon(null,GetPointX(40),GetPointY(40),GetPointX(41),GetPointY(41),0);

			pPlatoon5.BeginQuickRecord();
			pPlatoon5.CommandMove(GetPointX(42),GetPointY(34),0);//trasa przejazdu plutonu wroga
			pPlatoon5.CommandMove(GetPointX(43),GetPointY(35),0);
			pPlatoon5.CommandMove(GetPointX(44),GetPointY(36),0);
			pPlatoon5.CommandMove(GetPointX(45),GetPointY(22),0);
			pPlatoon5.CommandMove(GetPointX(38),GetPointY(38),0);
			pPlatoon5.EndQuickRecord();

			RemoveWorldMapSign(GetPointX(5),GetPointY(5),0);

			return Mission,50;
		}
		
		if(bInformationMineB==false//wstawiam mapsign po dotarciu Playera do m6
			&& IsUnitNearPoint(GetPointX(6),GetPointY(6),0,2,pPlayer.GetIFF()))
		{
			bInformationMineB=true;

			//pEnemy.CreateUnit(GetPointX(26)+0,GetPointY(26)+0,0,"RUS_BA20");
			//pEnemy.CreateUnit(GetPointX(26)+1,GetPointY(26)+0,0,"RUS_T26");
			pEnemy.CreateUnit(GetPointX(26)-1,GetPointY(26)+0,0,"RUS_SOLDIERSQUAD");
			pEnemy.CreateUnit(GetPointX(26)+0,GetPointY(26)+1,0,"RUS_SOLDIERSQUAD");
		
			pPlatoon3=pEnemy.CreatePlatoon(null,GetPointX(27),GetPointY(27),GetPointX(28),GetPointY(28),0);
			
			pPlatoon3.BeginQuickRecord();
			pPlatoon3.CommandMove(GetPointX(29),GetPointY(29),0);//trasa przejazdu plutonu wroga
			pPlatoon3.CommandMove(GetPointX(30),GetPointY(30),0);
			pPlatoon3.CommandMove(GetPointX(6),GetPointY(6),0);
			pPlatoon3.EndQuickRecord();

			//pEnemy.CreateUnit(GetPointX(46)+0,GetPointY(46)+0,0,"RUS_BA20");
			pEnemy.CreateUnit(GetPointX(46)+1,GetPointY(46)+0,0,"RUS_T26");
			pEnemy.CreateUnit(GetPointX(46)-1,GetPointY(46)+0,0,"RUS_T3485");
			//pEnemy.CreateUnit(GetPointX(46)+0,GetPointY(46)+1,0,"RUS_T3485");
		
			pPlatoon6=pEnemy.CreatePlatoon(null,GetPointX(47),GetPointY(47),GetPointX(48),GetPointY(48),0);
			
			pPlatoon6.BeginQuickRecord();
			pPlatoon6.CommandMove(GetPointX(42),GetPointY(42),0);//trasa przejazdu plutonu wroga
			pPlatoon6.CommandMove(GetPointX(43),GetPointY(43),0);
			pPlatoon6.CommandMove(GetPointX(44),GetPointY(44),0);
			pPlatoon6.CommandMove(GetPointX(49),GetPointY(49),0);
			pPlatoon6.CommandMove(GetPointX(50),GetPointY(50),0);
			pPlatoon6.CommandMove(GetPointX(51),GetPointY(51),0);
			pPlatoon6.EndQuickRecord();

			Rain(GetRight()/2,GetBottom()/2,256,100,2500,150,Rand(6));

			RemoveWorldMapSign(GetPointX(6),GetPointY(6),0);

			return Mission,50;
		}

		if(!hHero.IsLive())
		{
            SetGoalState(gHeroLive,goalFailed);
			AddBriefing(SND_GA_BRIEFING_FAIL,TRL_GA_BRIEFING_FAIL);
			EndMission(false);
			return Nothing,500;
		}

		return Mission,50;
    }

	//-----------------------------------------------------------------------------------------
	// state nothing, nigdy si nie zmienia zawsze jest taki
    state Nothing
    {
        return Nothing,500;
    }

	//-----------------------------------------------------------------------------------------
	event Timer0()
	{
		if(bTimerSetConsole)
		{
			--iTimerSetConsole;
			if(iTimerSetConsole==0)
			{
				SetConsoleText(1,""); SetConsoleText(2,""); SetConsoleText(3,"");
				bTimerSetConsole=false;
			}
		}

		if(bNalot)
		{
			--iNalot;
			if(iNalot==0)
			{
				bNalot=false;
				
				EnableCameraMovement(false);
				EnableInterface(false);

				pPlayer.LookAt(GetPointX(2),GetPointY(2),24,0,30,0);//kamera na marker2
				bDisabledCamera=true;
			}
		}

		if(bDesant)
		{
			--iDesant;
			if(iDesant==0)
			{
				bDesant=false;
				
                PlayWave("Fanfare.wav");
                PlayWave(SND_GA_CON_PARACHUTES,20);//MD!!!!!!!!!!!!!!!1
        
			    SetConsoleText(1,TRL_GA_CON_PARACHUTES);
			    SetConsoleText(2,"");
			    SetConsoleText(3,"");
			    bTimerSetConsole=true;
			    iTimerSetConsole=5;

				EnableCameraMovement(false);
				EnableInterface(false);

				pPlayer.LookAt(GetPointX(68),GetPointY(68),28,0,30,0);

				AddWorldMapSign(GetPointX(69),GetPointY(69),0,6,65000); //2 numer mapsign
				bMapSign4=true; 

				bDisabledCameraDesant=true;
			}
		}

		if(bMapSign1)
		{
			--iMapSign1; if(iMapSign1==0) {bMapSign1=false; RemoveWorldMapSign(GetPointX(8),GetPointY(8),0);}
		}

		if(bMapSign2)
		{
			--iMapSign2; if(iMapSign2==0) {bMapSign2=false; RemoveWorldMapSign(GetPointX(56),GetPointY(56),0);}
		}

		if(bMapSign3)
		{
			--iMapSign3; if(iMapSign3==0) {bMapSign3=false; RemoveWorldMapSign(GetPointX(67),GetPointY(67),0);}
		}
		if(bMapSign4)
		{
			--iMapSign4; if(iMapSign4==0) {bMapSign4=false; RemoveWorldMapSign(GetPointX(69),GetPointY(69),0);}
		}
	}
event Timer2()
{
    CheckSupplyLive();
}

	//-----------------------------------------------------------------------------------------
    command Uninitialize()
    {
		pPlatoon1=null;
		pPlatoon2=null;
		pPlatoon3=null;
		pPlatoon4=null;
		pPlatoon5=null;
		pPlatoon6=null;
		pPlatoon7=null;
		pPlatoon8=null;
		pPlatoon9=null;
		pPlatoon10=null;

		return true;
    }
}
