#include "..\..\Translates.ech"

mission TRL_USA24_SCRIPTNAME // zmiana
{
#define USE_TRACE
#include "..\..\Trace.ech"
#include "..\..\Common.ech"
#include "..\..\..\GameTypes\Production.ech"

    player pPlayer;
    player pEnemy;

	//platoon pEnemyPlatoon1,pEnemyPlatoon2,pEnemyPlatoon3,pEnemyPlatoon4,pEnemyPlatoon5,pEnemyPlatoon6;

	int bTimerEnabled;
	int iTimer;
	int iBuildingsPlayer;
	int bRoadToNextFactory;
	int bRoadToEnemyBase;
	int bRoadToTrainCenter;
	int bRoad0,bRoad1,bRoad2,bRoad3,bRoad4,bRoad5,bRoad6;
	int bRoad7,bRoad8,bRoad9,bRoad10,bRoad11;

    unitex uMineToCapture1;
    unitex uMineToCapture2;

    consts
    {
	//Goals
	gRadio=0;
	gFactoryFirst=1;
	gFactoryNext=2;
	gEnemyBase=3;
	gEnemy=4;

	//Artefact
	aRoad0=0;				//marker 8
	aRoad1=1;				//marker 9
	aRoad2=2;				//marker 10
	aRoad3=3;				//marker 11
	aRoad4=4;				//marker 12
	aRoad5=5;				//marker 13
	aRoad6=6;				//marker 14

	aRoad7=7;				//marker 15
	aRoad8=8;				//marker 16
	aRoad9=9;				//marker 17
	aRoad10=10;				//marker 18
	aRoad11=11;				//marker 19

    }

    state Initialize;
	state ShowBriefing;
	state Radio;
	state FactoryFirst;
	state FactoryNext;
	state EnemyBase;
	state EndMission;
    state Nothing;

	//Functions
	function int CheckUnitsCount()
	{
		if (pPlayer.GetNumberOfUnits()==0 && pPlayer.GetNumberOfBuildings()==0)
		{ 
			//AddBriefing(null, TRL_R13_BRIEFING_FAIL);

			return false;
		}

		return true;
	}

	//-----------------------------------------------------------------------------------------
    state Initialize
    {
	//---------- Players --------------------------
    pPlayer = GetPlayer(0); 
	pEnemy = GetPlayer(1);

	
	//---------- AI -------------------------------
	pPlayer.EnableStatistics(true);
	pEnemy.EnableStatistics(true);

	pPlayer.EnableAIFeatures(aiEnabled,false);
	pEnemy.EnableAIFeatures(aiEnabled,false);
	
    //----------- Units ---------------------------

    //----------- AI Units ------------------------
    //pEnemyPlatoon1=pEnemy.CreatePlatoon(null,GetPointX(29),GetPointY(29),GetPointX(30),GetPointY(30),0);
    //pEnemyPlatoon2=pEnemy.CreatePlatoon(null,GetPointX(31),GetPointY(31),GetPointX(32),GetPointY(32),0);
    //pEnemyPlatoon3=pEnemy.CreatePlatoon(null,GetPointX(33),GetPointY(33),GetPointX(34),GetPointY(34),0);
	//pEnemyPlatoon4=pEnemy.CreatePlatoon(null,GetPointX(27),GetPointY(27),GetPointX(28),GetPointY(28),0);
	//pEnemyPlatoon5=pEnemy.CreatePlatoon(null,GetPointX(42),GetPointY(42),GetPointX(43),GetPointY(43),0);
	//pEnemyPlatoon6=pEnemy.CreatePlatoon(null,GetPointX(44),GetPointY(44),GetPointX(45),GetPointY(45),0);

	//----------- Register Goal -------------------
	RegisterGoal(gRadio,TRL_T2_GOAL_RADIO);
	RegisterGoal(gFactoryFirst,TRL_T2_GOAL_FACTORYFIRST);
	RegisterGoal(gFactoryNext,TRL_T2_GOAL_FACTORYNEXT);
	RegisterGoal(gEnemyBase,TRL_T2_GOAL_ENEMYBASE);
	RegisterGoal(gEnemy,TRL_T2_GOAL_ENEMY);

	//___________ Artefacts ______________

	//----------- Enable Command -----------------
	pPlayer.EnableCommand(commandAutodestruction, false);  

	//----------- Prestige ------------------------
    pPlayer.SetMoney(4000);
    pPlayer.SetPlayerBankCapacity(4000);
	//----------- Time ----------------------------
	SetTime(149);

	//----------- Timer ---------------------------
	SetTimer(0,50);			// 1 s
	SetTimer(1,50);			// 1 s

	//----------- Console Text --------------------
	AddConsoleTextDisplay(0,0,100,SS_CENTER);
	AddConsoleTextDisplay(1,0,100,SS_CENTER);
	AddConsoleTextDisplay(2,0,100,SS_CENTER);
	AddConsoleTextDisplay(3,0,100,SS_CENTER);

	//----------- Camera --------------------------
	CallCamera();
	pPlayer.LookAt(pPlayer.GetStartingPointX(),pPlayer.GetStartingPointY(),12,0,9,0);
	SetGameRect(pPlayer.GetStartingPointX()-11,pPlayer.GetStartingPointY()-11,pPlayer.GetStartingPointX()+11,pPlayer.GetStartingPointY()+11);

	//----------- Variables -----------------------

    uMineToCapture1 = GetUnit(GetPointX(1),GetPointY(1));
    uMineToCapture2 = GetUnit(GetPointX(2),GetPointY(2));

	bTimerEnabled=false;
	iBuildingsPlayer = pPlayer.GetNumberOfBuildings();
	iTimer=0;
	bRoadToNextFactory=false;
	bRoadToEnemyBase=false;
	bRoadToTrainCenter=false;

	bRoad0=false; bRoad1=false; bRoad2=false; bRoad3=false; bRoad4=false;
	bRoad5=false; bRoad6=false;

	bRoad7=false; bRoad8=false; bRoad9=false; bRoad10=false; bRoad11=false;

	InitPlayerProduction(pPlayer);
	pPlayer.CaptureProductionPoint(0);	
    SelectBuildPanelTab(2);
    return ShowBriefing,50;			//1 sec
    }

	//-----------------------------------------------------------------------------------------
    state ShowBriefing
    {	
		EnableGoal(gRadio,true);

        AddBriefing(SND_T2_BRIEFING_START,TRL_T2_BRIEFING_START); 

		SetGameRect(GetPointX(0)-11,GetPointY(0)-11,GetPointX(0)+11,GetPointY(0)+11);
        SelectBuildPanelTab(2);
        return Radio,200;
    }

	//-----------------------------------------------------------------------------------------
    state Radio
    {
		if(pPlayer.GetNumberOfBuildings(buildingBombingControl) > 0)
		{
			SetGoalState(gRadio, goalAchieved);
			EnableGoal(gFactoryFirst,true);

			AddBriefing(SND_T2_BRIEFING_FIRSTMONEY,TRL_T2_BRIEFING_FIRSTMONEY);

			SetGameRect(0,0,0,0);

			AddWorldMapSign(GetPointX(1),GetPointY(1),0,0,65000);

			CreateArtefact("ART_ARROW_P",GetPointX(8),GetPointY(8),0,aRoad0,artefactSpecialAI);
			CreateArtefact("ART_ARROW_G",GetPointX(9),GetPointY(9),0,aRoad1,artefactSpecialAI);
			CreateArtefact("ART_ARROW_G",GetPointX(10),GetPointY(10),0,aRoad2,artefactSpecialAI);
			CreateArtefact("ART_ARROW_G",GetPointX(11),GetPointY(11),0,aRoad3,artefactSpecialAI);
			CreateArtefact("ART_ARROW_G",GetPointX(12),GetPointY(12),0,aRoad4,artefactSpecialAI);
			CreateArtefact("ART_ARROW_P",GetPointX(13),GetPointY(13),0,aRoad5,artefactSpecialAI);
			CreateArtefact("ART_ARROW_P",GetPointX(14),GetPointY(14),0,aRoad6,artefactSpecialAI);

			return FactoryFirst,200;
		}

		return Radio, 50;
	}

	//-----------------------------------------------------------------------------------------
    state FactoryFirst
    {
        
          
		//if(IsUnitNearPoint(GetPointX(1),GetPointY(1),0,1,pPlayer.GetIFF())
        //if(pPlayer.GetNumberOfBuildings(buildingMine) > 0))
        if( uMineToCapture1.GetIFF()== pPlayer.GetIFF())
		{
			SetGoalState(gFactoryFirst, goalAchieved);
			EnableGoal(gFactoryNext,true);

			AddBriefing(SND_T2_BRIEFING_MOVEPOINTS,TRL_T2_BRIEFING_MOVEPOINTS);

			RemoveWorldMapSign(GetPointX(1),GetPointY(1),0);
			AddWorldMapSign(GetPointX(2),GetPointY(2),0,0,65000);

			CreateArtefact("ART_ARROW_G",GetPointX(15),GetPointY(15),0,aRoad7,artefactSpecialAI);
			CreateArtefact("ART_ARROW_L",GetPointX(16),GetPointY(16),0,aRoad8,artefactSpecialAI);
			CreateArtefact("ART_ARROW_G",GetPointX(17),GetPointY(17),0,aRoad9,artefactSpecialAI);
			CreateArtefact("ART_ARROW_L",GetPointX(18),GetPointY(18),0,aRoad10,artefactSpecialAI);
			CreateArtefact("ART_ARROW_G",GetPointX(19),GetPointY(19),0,aRoad11,artefactSpecialAI);

            if(bRoad0==false)
		    {
			    bRoad0=true;
			    RemoveArtefact(GetPointX(8),GetPointY(8),0);
            }
		    if(bRoad1==false)
		    {
			    bRoad1=true;
			    RemoveArtefact(GetPointX(9),GetPointY(9),0);
		    }
		    if(bRoad2==false)
		    {
			    bRoad2=true;
			    RemoveArtefact(GetPointX(10),GetPointY(10),0);
		    }
		    if(bRoad3==false)
		    {
			    bRoad3=true;
			    RemoveArtefact(GetPointX(11),GetPointY(11),0);
            }
		    if(bRoad4==false)
		    {
			    bRoad4=true;
			    RemoveArtefact(GetPointX(12),GetPointY(12),0);
		    }
		    if(bRoad5==false)
		    {
			    bRoad5=true;
			    RemoveArtefact(GetPointX(13),GetPointY(13),0);
		    }
		    if(bRoad6==false)
		    {
			    bRoad6=true;
			    RemoveArtefact(GetPointX(14),GetPointY(14),0);
		    }
			return FactoryNext,50;
		}

        if(bRoad0==false 
			&& IsUnitNearPoint(GetPointX(8),GetPointY(8),0,2,pPlayer.GetIFF()))
		{
			bRoad0=true;
			RemoveArtefact(GetPointX(8),GetPointY(8),0);
		}
		if(bRoad1==false 
			&& IsUnitNearPoint(GetPointX(9),GetPointY(9),0,2,pPlayer.GetIFF()))
		{
			bRoad1=true;
			RemoveArtefact(GetPointX(9),GetPointY(9),0);
		}
		if(bRoad2==false 
			&& IsUnitNearPoint(GetPointX(10),GetPointY(10),0,2,pPlayer.GetIFF()))
		{
			bRoad2=true;
			RemoveArtefact(GetPointX(10),GetPointY(10),0);
		}
		if(bRoad3==false 
			&& IsUnitNearPoint(GetPointX(11),GetPointY(11),0,2,pPlayer.GetIFF()))
		{
			bRoad3=true;
			RemoveArtefact(GetPointX(11),GetPointY(11),0);
		}
		if(bRoad4==false 
			&& IsUnitNearPoint(GetPointX(12),GetPointY(12),0,2,pPlayer.GetIFF()))
		{
			bRoad4=true;
			RemoveArtefact(GetPointX(12),GetPointY(12),0);
		}
		if(bRoad5==false 
			&& IsUnitNearPoint(GetPointX(13),GetPointY(13),0,2,pPlayer.GetIFF()))
		{
			bRoad5=true;
			RemoveArtefact(GetPointX(13),GetPointY(13),0);
		}
		if(bRoad6==false 
			&& IsUnitNearPoint(GetPointX(14),GetPointY(14),0,4,pPlayer.GetIFF()))
		{
			bRoad6=true;
			RemoveArtefact(GetPointX(14),GetPointY(14),0);
        }
		return FactoryFirst,50;
	}

	//-----------------------------------------------------------------------------------------
    state FactoryNext
    {
		//if(IsUnitNearPoint(GetPointX(2),GetPointY(2),0,3,pPlayer.GetIFF()))
        if( uMineToCapture2.GetIFF() == pPlayer.GetIFF())
		{
			SetGoalState(gFactoryNext, goalAchieved);
			EnableGoal(gEnemyBase,true);

			AddBriefing(SND_T2_BRIEFING_FIRSTBASE,TRL_T2_BRIEFING_FIRSTBASE);
			RemoveWorldMapSign(GetPointX(2),GetPointY(2),0);
			AddWorldMapSign(GetPointX(3),GetPointY(3),0,1,65000);

            if(bRoad7==false)
		    {
			    bRoad7=true;
			    RemoveArtefact(GetPointX(15),GetPointY(15),0);
		    }
		    if(bRoad8==false)
		    {
			    bRoad8=true;
			    RemoveArtefact(GetPointX(16),GetPointY(16),0);
		    }
		    if(bRoad9==false)
		    {
			    bRoad9=true;
			    RemoveArtefact(GetPointX(17),GetPointY(17),0);
		    }
		    if(bRoad10==false)
		    {
			    bRoad10=true;
			    RemoveArtefact(GetPointX(18),GetPointY(18),0);
		    }
		    if(bRoad11==false)
		    {
			    bRoad11=true;
			    RemoveArtefact(GetPointX(19),GetPointY(19),0);
		    }
		    
			return EnemyBase,50;
		}

		if(bRoadToNextFactory == false && IsUnitNearPoint(GetPointX(5),GetPointY(5),0,5,pPlayer.GetIFF()))
		{
			bRoadToNextFactory = true;
            
            PlayWave("Fanfare.wav");
			PlayWave(SND_T2_CON_ENEMYATTACK1,20);

			SetConsoleText(1,TRL_T2_CON_ENEMYATTACK1);
			SetConsoleText(2,"");
			SetConsoleText(3,"");
			bTimerEnabled=true;
			iTimer=5;
		}

		if(bRoad7==false 
			&& IsUnitNearPoint(GetPointX(15),GetPointY(15),0,2,pPlayer.GetIFF()))
		{
			bRoad7=true;
			RemoveArtefact(GetPointX(15),GetPointY(15),0);
		}
		if(bRoad8==false 
			&& IsUnitNearPoint(GetPointX(16),GetPointY(16),0,2,pPlayer.GetIFF()))
		{
			bRoad8=true;
			RemoveArtefact(GetPointX(16),GetPointY(16),0);
		}
		if(bRoad9==false 
			&& IsUnitNearPoint(GetPointX(17),GetPointY(17),0,2,pPlayer.GetIFF()))
		{
			bRoad9=true;
			RemoveArtefact(GetPointX(17),GetPointY(17),0);
		}
		if(bRoad10==false 
			&& IsUnitNearPoint(GetPointX(18),GetPointY(18),0,2,pPlayer.GetIFF()))
		{
			bRoad10=true;
			RemoveArtefact(GetPointX(18),GetPointY(18),0);
		}
		if(bRoad11==false 
			&& IsUnitNearPoint(GetPointX(19),GetPointY(19),0,2,pPlayer.GetIFF()))
		{
			bRoad11=true;
			RemoveArtefact(GetPointX(19),GetPointY(19),0);
		}
		return FactoryNext,50;
	}

	//-----------------------------------------------------------------------------------------
    state EnemyBase
    {
		if(IsUnitNearPoint(GetPointX(3),GetPointY(3),0,15,pPlayer.GetIFF()) &&
			!IsUnitNearPoint(GetPointX(3),GetPointY(3),0,15,pEnemy.GetIFF()))
		{
			SetGoalState(gEnemyBase, goalAchieved);
			EnableGoal(gEnemy,true);

			AddBriefing(SND_T2_BRIEFING_MOVETOTRAIN,TRL_T2_BRIEFING_MOVETOTRAIN);

			RemoveWorldMapSign(GetPointX(3),GetPointY(3),0);
			AddWorldMapSign(GetPointX(4),GetPointY(4),0,1,65000);

			return EndMission,50;
		}

		if(bRoadToEnemyBase == false && IsUnitNearPoint(GetPointX(6),GetPointY(6),0,5,pPlayer.GetIFF()))
		{
			bRoadToEnemyBase = true;

            PlayWave("Fanfare.wav");
			PlayWave(SND_T2_CON_AIRATTACK1,20);

			SetConsoleText(1,TRL_T2_CON_AIRATTACK1);
			SetConsoleText(2,"");
			SetConsoleText(3,"");
			bTimerEnabled=true;
			iTimer=5;
		}

		return EnemyBase, 50;
	}

	//-----------------------------------------------------------------------------------------
    state EndMission
    {	
		// End Mission ---------------------------------------------------------------------
		if(IsUnitNearPoint(GetPointX(4),GetPointY(4),0,8,pPlayer.GetIFF()) &&
			!IsUnitNearPoint(GetPointX(4),GetPointY(4),0,14,pEnemy.GetIFF()))
		{
			SetGoalState(gEnemy, goalAchieved);

			RemoveWorldMapSign(GetPointX(4),GetPointY(4),0);

			AddBriefing(SND_T2_BRIEFING_VICTORY,TRL_T2_BRIEFING_VICTORY);
			
			EndMission(true);
		
			return Nothing,500;
		}

		if(bRoadToTrainCenter == false && IsUnitNearPoint(GetPointX(7),GetPointY(7),0,5,pPlayer.GetIFF()))
		{
            PlayWave("Fanfare.wav");
			PlayWave(SND_T2_CON_AIRCRAFT1,20);

			bRoadToTrainCenter = true;
			SetConsoleText(1,TRL_T2_CON_AIRCRAFT1);
			SetConsoleText(2,TRL_T2_CON_AIRCRAFT2);
			SetConsoleText(3,"");
			bTimerEnabled=true;
			iTimer=5;

			return EndMission,50;
		}

		return EndMission,50;
	}

	//
	state MissionFailed
	{
		AddBriefing(SND_T2_BRIEFING_FAIL, TRL_T2_BRIEFING_FAIL);
		
		EndMission(false);

		return Nothing,200;
	}

	//-----------------------------------------------------------------------------------------
    state Nothing
    {
        return Nothing,500;
    }

	//-----------------------------------------------------------------------------------------
	event Timer0()
	{
		if(bTimerEnabled)
		{
			iTimer=iTimer-1;
			if(iTimer==0)
			{
				//SetConsoleText(1,"");
				bTimerEnabled=false;
			}
		}
	}

	//-----------------------------------------------------------------------------------------
	event Timer1()
	{
		if (!CheckUnitsCount())
		{
			state MissionFailed;
		}
	}

	//----------------------------------------------------------------------------------------- 
	event UnitDestroyed(unit uUnit, player pKilledByPlayer)
	{
		//if(pKilledByPlayer!=null && uUnit.IsUpdate("GER_REPAIR")) --iUnitNotArmor;
	}

	//-----------------------------------------------------------------------------------------
    command Uninitialize()
    {
        /*pEnemyPlatoon1=null;
        pEnemyPlatoon2=null;
        pEnemyPlatoon3=null;
		pEnemyPlatoon4=null;
        pEnemyPlatoon5=null;
		pEnemyPlatoon6=null;*/

		return true;
    }
}
