mission "translateGameTypeUncleSam"
{
#include "Production.ech"

    consts
    {
		//Artefacts
		aHP=0;
		aAmmo=1;
		aAirStrike=2;
		aArtillery=3;
		aMoney=4;
    }
    
    int iStartingMoney;
    int iCashRate;
    int iCashTime;

	int iAirStrike;
	int iArtillery;
    
	//----------------------------------------------------------------------------------------- 
    enum comboMoney
    {
		"translateMultiPlayer_GameMenu_StartingMoney_0",
		"translateMultiPlayer_GameMenu_StartingMoney_5000",
		"translateMultiPlayer_GameMenu_StartingMoney_9000",
		"translateMultiPlayer_GameMenu_StartingMoney_15000",
		"translateMultiPlayer_GameMenu_StartingMoney_20000",
	multi:
        "translateMultiPlayer_GameMenu_StartingMoney"
    }

    enum comboCashRate
    {
"translateMultiPlayer_GameMenu_6000min",
"translateMultiPlayer_GameMenu_9000min",
"translateMultiPlayer_GameMenu_12000min",
"translateMultiPlayer_GameMenu_15000min",
"translateMultiPlayer_GameMenu_18000min",
multi:
      "translateGameMenuCashRate"
    }

	//----------------------------------------------------------------------------------------- 
    enum comboStartingUnits
    {
        "translateMultiPlayer_GameMenu_StartingUnits_DefaultCar",
        "translateMultiPlayer_GameMenu_StartingUnits_MediumUnit",
        "translateMultiPlayer_GameMenu_StartingUnits_HeavyUnit",
        "translateMultiPlayer_GameMenu_StartingUnits_OnlySoldiers",
	multi:
        "translateMultiPlayer_GameMenu_StartingUnits"
    }
    
	//----------------------------------------------------------------------------------------- 
    enum comboAlliedVictory
    {
        "translateMultiPlayer_GameMenu_AlliedVictory_No",
        "translateMultiPlayer_GameMenu_AlliedVictory_Yes",
	multi:
        "translateMultiPlayer_GameMenu_AlliedVictory"
    }
    
	//----------------------------------------------------------------------------------------- 
    function int CreateDefaultUnit(player pPlayer, int nX, int nY, int nZ)
    {
        if (pPlayer.GetRace()==raceGER)
        {
			if(comboStartingUnits==0)
				pPlayer.CreateUnit(nX,nY,nZ,"GER_SDKFZ222");
			if(comboStartingUnits==1)
			{
				pPlayer.CreateUnit(nX,nY,nZ,"GER_250_9");
				pPlayer.CreateUnit(nX+1,nY+0,nZ,"GER_SDKFZ222");
				pPlayer.CreateUnit(nX-1,nY+0,nZ,"GER_SDKFZ222");
				pPlayer.CreateUnit(nX+0,nY+1,nZ,"GER_PUMA");
				pPlayer.CreateUnit(nX+1,nY+1,nZ,"GER_BAZOOKASQUAD");

				pPlayer.CreateUnit(nX+1,nY-1,nZ,"GER_PANZER3F");
				pPlayer.CreateUnit(nX-1,nY+1,nZ,"GER_SOLDIERSQUAD");
				pPlayer.CreateUnit(nX-1,nY-1,nZ,"GER_SOLDIERSQUAD");
				pPlayer.CreateUnit(nX+0,nY+0,nZ,"GER_SOLDIERSQUAD");
				pPlayer.CreateUnit(nX+0,nY-1,nZ,"GER_SOLDIERSQUAD");
			}
			if(comboStartingUnits==2)
			{
				pPlayer.CreateUnit(nX,nY,nZ,"GER_PANZER4H");
				pPlayer.CreateUnit(nX+1,nY+0,nZ,"GER_250_9");
				pPlayer.CreateUnit(nX-1,nY+0,nZ,"GER_250_9");
				pPlayer.CreateUnit(nX+0,nY+1,nZ,"GER_BAZOOKASQUAD");
				pPlayer.CreateUnit(nX+1,nY+1,nZ,"GER_BAZOOKASQUAD");

				pPlayer.CreateUnit(nX+1,nY-1,nZ,"GER_PANTHER");
				pPlayer.CreateUnit(nX-1,nY+1,nZ,"GER_TIGER");
				pPlayer.CreateUnit(nX-1,nY-1,nZ,"GER_SDKFZ222");
				pPlayer.CreateUnit(nX+0,nY+0,nZ,"GER_SOLDIERSQUAD");
				pPlayer.CreateUnit(nX+0,nY-1,nZ,"GER_SOLDIERSQUAD");
			}
			if(comboStartingUnits==3)
			{
				pPlayer.CreateUnit(nX,nY,nZ,"GER_SOLDIERSQUAD");
				pPlayer.CreateUnit(nX+1,nY+0,nZ,"GER_SOLDIERSQUAD");
			}
        }

        if (pPlayer.GetRace()==raceRUS)
        {
			if(comboStartingUnits==0)
				pPlayer.CreateUnit(nX,nY,nZ,"RUS_BA20");
			if(comboStartingUnits==1)
			{
				pPlayer.CreateUnit(nX,nY,nZ,"RUS_HALFTRUCK");
				pPlayer.CreateUnit(nX+1,nY+0,nZ,"RUS_BA20");
				pPlayer.CreateUnit(nX-1,nY+0,nZ,"RUS_BA20");
				pPlayer.CreateUnit(nX+0,nY+1,nZ,"RUS_T26");
				pPlayer.CreateUnit(nX+1,nY+1,nZ,"RUS_T26");

				pPlayer.CreateUnit(nX+1,nY-1,nZ,"RUS_BAZOOKASQUAD");
				pPlayer.CreateUnit(nX-1,nY+1,nZ,"RUS_SOLDIERSQUAD");
				pPlayer.CreateUnit(nX-1,nY-1,nZ,"RUS_SOLDIERSQUAD");
				pPlayer.CreateUnit(nX+0,nY+0,nZ,"RUS_SOLDIERSQUAD");
				pPlayer.CreateUnit(nX+0,nY-1,nZ,"RUS_SOLDIERSQUAD");
			}
			if(comboStartingUnits==2)
			{
				pPlayer.CreateUnit(nX,nY,nZ,"RUS_BA20");
				pPlayer.CreateUnit(nX+1,nY+0,nZ,"RUS_SOLDIERSQUAD");
				pPlayer.CreateUnit(nX-1,nY+0,nZ,"RUS_SOLDIERSQUAD");
				pPlayer.CreateUnit(nX+0,nY+1,nZ,"RUS_BAZOOKASQUAD");
				pPlayer.CreateUnit(nX+1,nY+1,nZ,"RUS_BAZOOKASQUAD");

				pPlayer.CreateUnit(nX+1,nY-1,nZ,"RUS_HALFTRUCK");
				pPlayer.CreateUnit(nX-1,nY+1,nZ,"RUS_HALFTRUCK");
				pPlayer.CreateUnit(nX-1,nY-1,nZ,"RUS_IS3");
				pPlayer.CreateUnit(nX+0,nY+0,nZ,"RUS_T3485");
				pPlayer.CreateUnit(nX+0,nY-1,nZ,"RUS_SU76");
			}
			if(comboStartingUnits==3)
			{
				pPlayer.CreateUnit(nX,nY,nZ,"RUS_SOLDIERSQUAD");
				pPlayer.CreateUnit(nX+1,nY+0,nZ,"RUS_SOLDIERSQUAD");
			
			}
        }

        if (pPlayer.GetRace()==raceUSA)
        {
			if(comboStartingUnits==0)
				pPlayer.CreateUnit(nX,nY,nZ,"USA_JEEP");
			if(comboStartingUnits==1)
			{
				pPlayer.CreateUnit(nX,nY,nZ,"USA_GREYHOUND");
				pPlayer.CreateUnit(nX+1,nY+0,nZ,"USA_SOLDIERSQUAD");
				pPlayer.CreateUnit(nX-1,nY+0,nZ,"USA_SOLDIERSQUAD");
				pPlayer.CreateUnit(nX+0,nY+1,nZ,"USA_SOLDIERSQUAD");
				pPlayer.CreateUnit(nX+1,nY+1,nZ,"USA_SOLDIERSQUAD");

				pPlayer.CreateUnit(nX+1,nY-1,nZ,"USA_BAZOOKASQUAD");
				pPlayer.CreateUnit(nX-1,nY+1,nZ,"USA_STUART");
				pPlayer.CreateUnit(nX-1,nY-1,nZ,"USA_JEEP");
				pPlayer.CreateUnit(nX+0,nY+0,nZ,"USA_JEEP");
				pPlayer.CreateUnit(nX+0,nY-1,nZ,"USA_HALFTRUCK");
			}
			if(comboStartingUnits==2)
			{
				pPlayer.CreateUnit(nX,nY,nZ,"USA_SHERFIREFLY");
				pPlayer.CreateUnit(nX+1,nY+0,nZ,"USA_HALFTRUCK");
				pPlayer.CreateUnit(nX-1,nY+0,nZ,"USA_HALFTRUCK");
				pPlayer.CreateUnit(nX+0,nY+1,nZ,"USA_BAZOOKASQUAD");
				pPlayer.CreateUnit(nX+1,nY+1,nZ,"USA_BAZOOKASQUAD");

				pPlayer.CreateUnit(nX+1,nY-1,nZ,"USA_SHERJUMBO");
				pPlayer.CreateUnit(nX-1,nY+1,nZ,"USA_PERSHING");
				pPlayer.CreateUnit(nX-1,nY-1,nZ,"USA_SOLDIERSQUAD");
				pPlayer.CreateUnit(nX+0,nY+0,nZ,"USA_SOLDIERSQUAD");
				pPlayer.CreateUnit(nX+0,nY-1,nZ,"USA_JEEP");
			}
			if(comboStartingUnits==3)
			{
				pPlayer.CreateUnit(nX,nY,nZ,"USA_SOLDIERSQUAD");
				pPlayer.CreateUnit(nX+1,nY+0,nZ,"USA_SOLDIERSQUAD");
			}
        }

        return true;
    }

    state Initialize;
    state Nothing;
    
	//----------------------------------------------------------------------------------------- 
    state Initialize
    {
    player pPlayer;
    int i,j;
	SelectBuildPanelTab(2);            
	if(comboMoney==0) iStartingMoney = 0;
	if(comboMoney==1) iStartingMoney = 5000;
	if(comboMoney==2) iStartingMoney = 9000;
	if(comboMoney==3) iStartingMoney = 15000;
	if(comboMoney==4) iStartingMoney = 20000;
    
	if(comboCashRate==0) {iCashTime = 60*20; iCashRate = 6000;}
	if(comboCashRate==1) {iCashTime = 60*20; iCashRate = 9000;}
	if(comboCashRate==2) {iCashTime = 60*20; iCashRate = 12000;}
	if(comboCashRate==3) {iCashTime = 60*20; iCashRate = 15000;}
	if(comboCashRate==4) {iCashTime = 60*20; iCashRate = 18000;}

	//----------- Create Artefactr ----------------
	
	//----------- Console Text --------------------
	AddConsoleTextDisplay(0,0,100,SS_CENTER);
	AddConsoleTextDisplay(1,0,100,SS_CENTER);
	AddConsoleTextDisplay(2,0,100,SS_CENTER);
	AddConsoleTextDisplay(3,0,100,SS_CENTER);
	AddConsoleTextDisplay(4,0,100,SS_CENTER);


        
    for(i=0;i<8;i=i+1)
    {
        pPlayer=GetPlayer(i);

        if(pPlayer!=null  && pPlayer.IsAlive()) 
        {
	        InitPlayerProduction(pPlayer);
			
			pPlayer.EnableAIFeatures3(ai3BuildPrestigeDeposit,false);
	
			pPlayer.SetPlayerBankCapacity(100000);
			pPlayer.AddMoney(iStartingMoney);
            pPlayer.LookAt(pPlayer.GetStartingPointX(),pPlayer.GetStartingPointY(),6,0,20,0);
            
            if (comboStartingUnits>0)
                CreateDefaultUnit(pPlayer,pPlayer.GetStartingPointX(),pPlayer.GetStartingPointY(),0);
	//aktywacja playerw		
			pPlayer.CaptureProductionPoint(i);

			pPlayer.EnableCommand(commandAutodestruction, false); 
			//pPlayer.EnableCommand(commandExitCrew, false); 
			if(comboAlliedVictory)
				pPlayer.EnableAIFeatures(aiRejectAlliance, false);

        }
    }

	SetTimer(0,100);
	SetTimer(1,iCashTime);
	AddBriefing(null,"translateGameTypeUncleSamDescription");	
	return Nothing;
    }
    
	//----------------------------------------------------------------------------------------- 
    state Nothing
    {
        return Nothing;
    }
    
	//----------------------------------------------------------------------------------------- 
    event RemoveUnits()
    {
        if(comboStartingUnits)
            return true;
            
		return false;
    }
    event RemoveResources()
    {
		return true;
    }
    
	//----------------------------------------------------------------------------------------- 
    event Timer0()
    {
		player pPlayer;
        player pPlayer2;
        player pVictoryPlayer;

        int i;
        int j;
		int iAlivePlayers;
        int iCountUnits;
        
		int bIsEnemy;

        pVictoryPlayer=null;
        iAlivePlayers=0;

        if(comboAlliedVictory)//--------------------------------------------------------------
        {
            for(i=0;i<8;i=i+1)
            {
                pPlayer = GetPlayer(i);
                if(pPlayer!=null && pPlayer.IsAlive()) 
				{
                    iCountUnits = pPlayer.GetNumberOfActiveTrains() + pPlayer.GetNumberOfUnits() + pPlayer.GetNumberOfBuildings();
                    if (iCountUnits==0) 
					{
						pPlayer.Defeat();
					}
                }
            }
            
            bIsEnemy=false;
            for(i=0;i<8;i=i+1)
            {
                pPlayer = GetPlayer(i);
                if(pPlayer!=null && pPlayer.IsAlive()) 
                {
                    for(j=i+1;j<8;j=j+1)
                    {
                        pPlayer2 = GetPlayer(j);
                        if(pPlayer2!=null && pPlayer2.IsAlive() && !pPlayer.IsAlly(pPlayer2))  
                        {
                            bIsEnemy=true;
                        }
                    }
                }
            }

            if(bIsEnemy) return;
            
            for(i=0;i<8;i=i+1)
            {
                pPlayer = GetPlayer(i);
                if(pPlayer!=null && pPlayer.IsAlive()) 
                {
                    pPlayer.Victory();
                }
            }
        }
        else//---------------------------------------------------------------------------------
        {
            for(i=0;i<8;i=i+1)
            {
                pPlayer = GetPlayer(i);
                if(pPlayer!=null && pPlayer.IsAlive()) 
                {
                    iCountUnits = pPlayer.GetNumberOfActiveTrains() + pPlayer.GetNumberOfUnits() + pPlayer.GetNumberOfBuildings();
                    if (iCountUnits!=0)
                    {
                        iAlivePlayers=iAlivePlayers+1;
                        pVictoryPlayer=pPlayer;
                    }
                    else
                    {
                        pPlayer.Defeat();
                    }
                }
            }

            if (iAlivePlayers==1 && pVictoryPlayer!=null)
            {
                pVictoryPlayer.Victory();
            }
        }
    }
    
	//----------------------------------------------------------------------------------------- 
    event Timer1()
    {
        int i;
        player pPlayer;
        
        for(i=0;i<8;i=i+1)
        {
			pPlayer=GetPlayer(i);
            if(pPlayer!=null  && pPlayer.IsAlive()) 
            {
				pPlayer.AddMoney(iCashRate);
            }
        }
    }
  
	//-----------------------------------------------------------------------------------------
    event Artefact(int aID,player pPlayer)
    {			
		if(aID==aHP) RegenerateUnitsHPInArea(pPlayer.GetIFF(),GetPointX(0),GetPointY(0),0,10);

		if(aID==aAmmo) RegenerateUnitsAmmoInArea(pPlayer.GetIFF(),GetPointX(1),GetPointY(1),0,10);

		if(aID==aAirStrike) pPlayer.AddArtileryOrAirStrike(iAirStrike,5);

		if(aID==aArtillery) pPlayer.AddArtileryOrAirStrike(iArtillery,5);

		if(aID==aMoney) pPlayer.AddMoney(100);

        return true;
    }

	//----------------------------------------------------------------------------------------- 
	event UnitDestroyed(unit uUnit, player pKilledByPlayer)
	{
	}
 
	//----------------------------------------------------------------------------------------
    event BuildingDestroyed(unit uUnit, player pKilledByPlayer)
    {
    }	

	//----------------------------------------------------------------------------------------- 
	event SetupInterface()
	{
		int iSetupInterface;

		if(comboAlliedVictory) 
		{
			iSetupInterface=0;
		}
		else 
		{
			iSetupInterface=lockAllianceDialog | 
							lockGiveMoneyDialog | 
							lockGiveUnitsDialog |
							lockToolbarAlliance | 
							lockToolbarGiveMoney;
		}

        EnableGameFeature(
			iSetupInterface |
            //lockAllianceDialog |
            //lockGiveMoneyDialog |
            //lockGiveUnitsDialog |
            //lockShowToolbar |
            //lockToolbarMap |
            //lockToolbarPanel |
            lockToolbarLevelName |
            //lockToolbarMenu |
            //lockToolbarMoney |
			//lockToolbarAlliance |
			//lockToolbarGiveMoney |
            //lockDisplayToolbarLevelName |
            //lockDisplayToolbarMoney |
            0,
            true);
	}

	//----------------------------------------------------------------------------------------- 
    command Initialize()
    {
		comboMoney = 0;
		comboStartingUnits=3;
		comboCashRate = 1;
        comboAlliedVictory=1;
		return true;
    }
    
	//----------------------------------------------------------------------------------------- 
    command Combo1(int iMode) button comboMoney
    {
        comboMoney = iMode;

		return true;
    }
    
	//----------------------------------------------------------------------------------------- 
    command Combo2(int nMode) button comboCashRate
    {
        comboCashRate = nMode;
				
		return true;
    }
    
	//----------------------------------------------------------------------------------------- 
    command Combo3(int iMode) button comboStartingUnits 
    {
        comboStartingUnits = iMode;

		return true;
    }

	//----------------------------------------------------------------------------------------- 
    command Combo4(int iMode) button comboAlliedVictory
    {
        comboAlliedVictory = iMode;

		return true;
    }
}
