#include "..\..\Translates.ech"

mission TRL_USA24_SCRIPTNAME // zmiana
{
#define USE_TRACE
#include "..\..\Trace.ech"
#include "..\..\Common.ech"

    player pPlayer;
    player pEnemy;
	player pPlayer2;
	player pPlayer3;

	platoon pEnemyPlatoon1,pEnemyPlatoon2,pEnemyPlatoon3,pEnemyPlatoon4,pEnemyPlatoon5,pEnemyPlatoon6;

    unit uSupplyBuilding;
	unitex uUnit;			// unit gracza na starcie
	
	unitex uUnit11;			// beczki do zniszczenia (24)
	unitex uUnit12;
	unitex uUnit13;
	unitex uUnit14;

	unitex uSupply;			// pojazd supply (5)
	unitex uUnit22;			// skad amunicji 1
	unitex uUnit23;			// skad amunicji 2

	unitex uRepair;			// unit Repair 31

	int bTimerEnabled;
	int bRoad0,bRoad1,bRoad2,bRoad3,bRoad4,bRoad5,bRoad6,bRoad7,bRoad8,bRoad9;
	int bRoad10,bRoad11,bRoad12,bRoad13,bRoad14,bRoad15,bRoad16,bRoad17,bRoad18,bRoad19;
	int bRoad20,bRoad21,bRoad22,bRoad23;
	int bPlatoon;
	int iTimer;
	int iUnitAmmo;
	int bCheckTiger;
    int bCheckBuildings;
    int iSupplyDestroyed;

	int LightBomber;
	int HeavyBomber;
	int Artillery;

	int bEnemy1;
	int bEnemy2;

    consts
    {
	//Artefact
	aRoad0=0;				//marker 0
	aRoad1=1;				//marker 1
	aRoad2=2;				//marker 2

	aRoad3=3;				//marker 3
	aRoad4=4;				//marker 4
	aRoad5=5;				//marker 5

	aRoad6=6;				//marker 6
	aRoad7=7;				//marker 7
	aRoad8=8;				//marker 8

	aRoad9=9;				//marker 9
	aRoad10=10;				//marker 10
	aRoad11=11;				//marker 11
	aRoad12=12;				//marker 12

	aRoad13=13;				//marker 13
	aRoad14=14;				//marker 14
	aRoad15=15;				//marker 15
	aRoad16=16;				//marker 16
	aRoad17=17;				//marker 17
	aRoad18=18;				//marker 18

	aRoad19=19;				//marker 19
	aRoad20=20;				//marker 20
	aRoad21=21;				//marker 21
	aRoad22=22;				//marker 22
	aRoad23=23;				//marker 23

	aVillage=24;			//marker 25
	aV2=24;					//marker 39

	//Goals
	gBarrels=0;
	gDestroyTanks=1;
	gSupply=2;
	gUnits=3;
	gSoldiers=4;
	gVillage=5;
	gAircraft=6;
	gV2=7;
	gEnemy=8;
    }

    state Initialize;
	state ShowBriefing;
	state Barell;
	state EnemyTanks;
	state Supply;
	state Units;
	state Soldiers;
	state Village;
	state Aircraft;
	state V2;
	state V2Attack;
	state EndMission;
    state Nothing;

	//Functions

    function int SetGameRectEx(unitex uUnit, int x1,int y1,int x2,int y2)
    {
        
        if(x1>uUnit.GetLocationX()) x1 = uUnit.GetLocationX()-1;
        if(y1>uUnit.GetLocationY()) y1 = uUnit.GetLocationY()-1;
        if(x2<uUnit.GetLocationX()) x2 = uUnit.GetLocationX()+1;
        if(y2<uUnit.GetLocationY()) y2 = uUnit.GetLocationY()+1;
        SetGameRect(x1,y1,x2,y2);
        return 1;
    }
	function int CheckUnitsCount()
	{
        int noU;
        noU=pPlayer.GetNumberOfUnits();


        if( !noU || (noU==1 && uSupply.IsLive()))
        {
            if(bCheckBuildings)
            {
		        if (pPlayer.GetNumberOfBuildings()==0)
                { 
			        return false;
		        }
            }
            else
            {
    	        return false;
            }
        }

		return true;
	}

	function int CheckTigerLive()
	{
		
		if(bCheckTiger && uUnit!=null)
		{
			if (!uUnit.IsLive() && bPlatoon==false)
			{ 
				return false;
			}
		}
		return true;
	}

	function int CheckSupplyLive()
	{
		if ((uSupply==null || !uSupply.IsLive()) && bRoad5 == true)
		{
			uSupply = pPlayer.CreateUnit(GetPointX(35),GetPointY(35),0,"GER_SUPL1");
			if(uSupply != null)
			{
				uSupply.CommandMove(GetPointX(5)-2,GetPointY(5),0);
			}
		}

		return true;
	}

	//-----------------------------------------------------------------------------------------
    state Initialize
    {
	//---------- Players --------------------------
    pPlayer = GetPlayer(0); 
	pEnemy = GetPlayer(1);
	pPlayer2 = GetPlayer(3);
	pPlayer3 = GetPlayer(4);

	//---------- AI -------------------------------
	pPlayer.EnableStatistics(true);
	pPlayer2.EnableStatistics(false);
	pPlayer3.EnableStatistics(false);
	pEnemy.EnableStatistics(true);

	pPlayer.EnableAIFeatures(aiEnabled,false);
	pPlayer2.EnableAIFeatures(aiEnabled,false);
	pPlayer3.EnableAIFeatures(aiEnabled,false);
	pEnemy.EnableAIFeatures(aiEnabled,false);

	pPlayer2.EnableAIFeatures(aiControlOffense,false);
    pPlayer2.EnableAIFeatures(aiRejectAlliance, false);
	pPlayer2.EnableAIFeatures2(ai2ChooseEnemy, false);
	pPlayer3.EnableAIFeatures(aiControlOffense,false);
    pPlayer3.EnableAIFeatures(aiRejectAlliance, false);
	pPlayer3.EnableAIFeatures2(ai2ChooseEnemy, false);

	pPlayer.SetAlly(pPlayer2);
	pPlayer.SetAlly(pPlayer3);
	
	pPlayer2.SetAlly(pPlayer3);
	
    pEnemy.SetNeutral(pPlayer);
    pPlayer.SetNeutral(pEnemy);
    pPlayer2.SetNeutral(pEnemy);
    pPlayer3.SetNeutral(pEnemy);
    
    //----------- Units ---------------------------
    uUnit=GetUnit(pPlayer.GetStartingPointX(),pPlayer.GetStartingPointY(),0);

    uUnit11=GetUnit(GetPointX(24)+0,GetPointY(24)+0,0);
    uUnit12=GetUnit(GetPointX(24)+1,GetPointY(24)-1,0);
    uUnit13=GetUnit(GetPointX(24)+1,GetPointY(24)+1,0);
    uUnit14=GetUnit(GetPointX(24)+1,GetPointY(24)+0,0);

    uUnit22=GetUnit(GetPointX(5)-1,GetPointY(5)-2,0);
    uUnit23=GetUnit(GetPointX(5)-4,GetPointY(5)+0,0);

    //----------- AI Units ------------------------
    pEnemyPlatoon1=pEnemy.CreatePlatoon(null,GetPointX(29),GetPointY(29),GetPointX(30),GetPointY(30),0);
    pEnemyPlatoon2=pEnemy.CreatePlatoon(null,GetPointX(31),GetPointY(31),GetPointX(32),GetPointY(32),0);
    pEnemyPlatoon3=pEnemy.CreatePlatoon(null,GetPointX(33),GetPointY(33),GetPointX(34),GetPointY(34),0);
	pEnemyPlatoon4=pEnemy.CreatePlatoon(null,GetPointX(27),GetPointY(27),GetPointX(28),GetPointY(28),0);
	pEnemyPlatoon5=pEnemy.CreatePlatoon(null,GetPointX(42),GetPointY(42),GetPointX(43),GetPointY(43),0);
	pEnemyPlatoon6=pEnemy.CreatePlatoon(null,GetPointX(44),GetPointY(44),GetPointX(45),GetPointY(45),0);

	//----------- Register Goal -------------------
	RegisterGoal(gBarrels,"translateGer_T_1_Goal_Barrels");
	RegisterGoal(gDestroyTanks,"translateGer_T_1_Goal_DestroyTanks");
	RegisterGoal(gSupply,"translateGer_T_1_Goal_Supply");
	RegisterGoal(gUnits,"translateGer_T_1_Goal_Units");
	RegisterGoal(gSoldiers,"translateGer_T_1_Goal_Soldiers");
	RegisterGoal(gVillage,"translateGer_T_1_Goal_Village");
	RegisterGoal(gAircraft,"translateGer_T_1_Goal_Aircraft");
	RegisterGoal(gV2,"translateGer_T_1_Goal_V2");
	RegisterGoal(gEnemy,"translateGer_T_1_Goal_Enemy");

	//___________ Artefacts ______________
	CreateArtefact("ART_ARROW_P",GetPointX(0),GetPointY(0),0,aRoad0,artefactSpecialAI);
	CreateArtefact("ART_ARROW_PD",GetPointX(1),GetPointY(1),0,aRoad1,artefactSpecialAI);
	CreateArtefact("ART_ARROW_P",GetPointX(2),GetPointY(2),0,aRoad2,artefactSpecialAI);
	CreateArtefact("ART_ZNAKRUS",GetPointX(25),GetPointY(25),0,aVillage,artefactSpecialAI);
	CreateArtefact("ART_ZNAKRUS",GetPointX(39),GetPointY(39),0,aV2,artefactSpecialAI);
	
	//----------- Enable Command -----------------
	pPlayer.EnableCommand(commandAutodestruction, false);  
	pPlayer.EnableCommand(commandExitCrew,false);
	//----------- Prestige ------------------------
    pPlayer.SetMoney(5000);
    iSupplyDestroyed = 0;    
	//----------- Time ----------------------------
	SetTime(118);

	//----------- Timer ---------------------------
	SetTimer(0,50);			// 1 s
	SetTimer(1,50);			// 1 s
    SetTimer(2, 1200);     // 1min
	//----------- Console Text --------------------
	AddConsoleTextDisplay(0,0,100,SS_CENTER);
	AddConsoleTextDisplay(1,0,100,SS_CENTER);
	AddConsoleTextDisplay(2,0,100,SS_CENTER);
	AddConsoleTextDisplay(3,0,100,SS_CENTER);

	//----------- Camera --------------------------
	CallCamera();
	pPlayer.LookAt(pPlayer.GetStartingPointX(),pPlayer.GetStartingPointY(),12,0,9,0);
	SetGameRect(GetPointX(35)-11,GetPointY(35)-11,GetPointX(35)+11,GetPointY(35)+11);

	//----------- Variables -----------------------
	bTimerEnabled=false;
	bRoad0=false; bRoad1=false; bRoad2=false; bRoad3=false; bRoad4=false;
	bRoad5=false; bRoad6=false; bRoad7=false; bRoad8=false; bRoad9=false;
	bRoad10=false; bRoad11=false; bRoad12=false; bRoad13=false; bRoad14=false;
	bRoad15=false; bRoad16=false; bRoad17=false; bRoad18=false; bRoad19=false;
	bRoad20=false; bRoad21=false; bRoad22=false; bRoad23=false;
	bPlatoon=false;
	bEnemy1=false;
	bEnemy2=false;
	bCheckTiger=false;
    bCheckBuildings=false;
	iTimer=0;			
	iUnitAmmo=uUnit.GetMaxAmmo();
	SetHelpMode(true);
	
	
    return ShowBriefing,50;			//1 sec
    }

	//-----------------------------------------------------------------------------------------
    state ShowBriefing
    {	
		bCheckTiger=true;
        AddBriefing(SND_T1_BRIEFING_START,TRL_T1_BRIEFING_START); 
        PlayWave("Fanfare.wav",20);
        PlayWave(SND_T1_CON_START,40);
        SetConsoleText(1,TRL_T1_CON_START);
		SetConsoleText(2,"");
		SetConsoleText(3,"");

		SetGameRect(GetPointX(1)-20,GetPointY(1)-8,GetPointX(1)+16,GetPointY(1)+8);
		
		AddWorldMapSign(GetPointX(24),GetPointY(24),0,0,65000);

        return Barell,50;
    }

	//-----------------------------------------------------------------------------------------
    state Barell
    {

		if(!uUnit.GetAmmo())
			uUnit.RegenerateAmmo();

		if(GetGoalState(gBarrels)!=goalAchieved 
			&& !uUnit11.IsLive() && !uUnit12.IsLive() 
			&& !uUnit13.IsLive() && !uUnit14.IsLive())
		{
            if(bRoad0==false) RemoveArtefact(GetPointX(0),GetPointY(0),0);
            if(bRoad1==false) RemoveArtefact(GetPointX(1),GetPointY(1),0);
		    if(bRoad2==false) RemoveArtefact(GetPointX(2),GetPointY(2),0);
        
			SetGoalState(gBarrels, goalAchieved);
			EnableGoal(gDestroyTanks,true);
            PlayWave("Fanfare.wav",20);
            PlayWave(SND_T1_CON_BARRELSEND,40);
			SetConsoleText(1,TRL_T1_CON_BARRELSEND);
			SetConsoleText(2,"");
			SetConsoleText(3,"");
			bTimerEnabled=true;
			iTimer=5;

			RemoveWorldMapSign(GetPointX(24),GetPointY(24),0);
			SetGameRectEx(uUnit,GetPointX(4)-8,GetPointY(4),GetPointX(4)+7,GetPointY(4)+18);

			pEnemyPlatoon4.CommandMove(GetPointX(3),GetPointY(3)+2,0);

            pEnemy.SetEnemy(pPlayer);
            pPlayer.SetEnemy(pEnemy);
    

			return EnemyTanks,50;
		}

		if(bRoad0==false
			&& Distance(uUnit.GetLocationX(),uUnit.GetLocationY(),GetPointX(0),GetPointY(0))<4)
		
        {
			bRoad0=true;
			RemoveArtefact(GetPointX(0),GetPointY(0),0);

			return Barell,50;
		}

		if(bRoad1==false
			&& Distance(uUnit.GetLocationX(),uUnit.GetLocationY(),GetPointX(1),GetPointY(1))<4)
		{
			bRoad1=true;
			RemoveArtefact(GetPointX(1),GetPointY(1),0);

			return Barell,50;
		}

		if(bRoad2==false
			&& Distance(uUnit.GetLocationX(),uUnit.GetLocationY(),GetPointX(2),GetPointY(2))<4)
		{
			bRoad2=true;
		    RemoveArtefact(GetPointX(2),GetPointY(2),0);
			PlayWave("Fanfare.wav",20);
            PlayWave(SND_T1_CON_BARRELS,40);
			SetConsoleText(1,TRL_T1_CON_BARRELS);
			SetConsoleText(2,"");
			SetConsoleText(3,"");

			RemoveWorldMapSign(GetPointX(24),GetPointY(24),0);
			AddWorldMapSign(GetPointX(24),GetPointY(24),0,1,65000);
			
			AddBriefing(SND_T1_BRIEFING_BARRELS,TRL_T1_BRIEFING_BARRELS);
			EnableGoal(gBarrels,true);
			return Barell,50;
		}

		return Barell, 50;
	}

	//-----------------------------------------------------------------------------------------
    state EnemyTanks
    {
		if(!uUnit.GetAmmo())
			uUnit.RegenerateAmmo();


		if(GetGoalState(gDestroyTanks)!=goalAchieved && pEnemyPlatoon4.GetUnitsCount()==0)
		{
			pPlayer.EnableCommand(commandExitCrew,true);
			SetGoalState(gDestroyTanks, goalAchieved);
			AddWorldMapSign(GetPointX(5),GetPointY(5),0,0,65000);
            PlayWave("Fanfare.wav");
            PlayWave(SND_T1_CON_NORTH,20);
			SetConsoleText(1,TRL_T1_CON_NORTH);
			SetConsoleText(2,"");
			SetConsoleText(3,"");
			bTimerEnabled=true;
			iTimer=5;
		    SetGameRectEx(uUnit,GetPointX(4)-11,GetPointY(4)-9,GetPointX(4)+7,GetPointY(4)+18);
			CreateArtefact("ART_ARROW_G",GetPointX(3),GetPointY(3),0,aRoad3,artefactSpecialAI);
			CreateArtefact("ART_ARROW_G",GetPointX(4),GetPointY(4),0,aRoad4,artefactSpecialAI);
			CreateArtefact("ART_ARROW_L",GetPointX(5),GetPointY(5),0,aRoad5,artefactSpecialAI);	

			return Supply,50;
		}
	}

	//-----------------------------------------------------------------------------------------
    state Supply
    {
		if(GetGoalState(gSupply)!=goalAchieved && uUnit.GetAmmo()>iUnitAmmo)
		{

            if(bRoad3==false)RemoveArtefact(GetPointX(3),GetPointY(3),0);
		    if(bRoad4==false)RemoveArtefact(GetPointX(4),GetPointY(4),0);
		    if(bRoad5==false)RemoveArtefact(GetPointX(5),GetPointY(5),0);
		

			SetGoalState(gSupply, goalAchieved);
            PlayWave("Fanfare.wav",20);
            PlayWave(SND_T1_CON_SUPPLYEND,40);
			SetConsoleText(1,TRL_T1_CON_SUPPLYEND);
			SetConsoleText(2,"");
			SetConsoleText(3,"");
			bTimerEnabled=true;
			iTimer=5;

			SetGameRectEx(uUnit,GetPointX(7)-9,GetPointY(7)-9,GetPointX(7)+5,GetPointY(4)+18);

			RemoveWorldMapSign(GetPointX(5),GetPointY(5),0);
			AddWorldMapSign(GetPointX(8),GetPointY(8),0,2,65000);

			CreateArtefact("ART_ARROW_PG",GetPointX(6),GetPointY(6),0,aRoad6,artefactSpecialAI);
			CreateArtefact("ART_ARROW_G",GetPointX(7),GetPointY(7),0,aRoad7,artefactSpecialAI);
			CreateArtefact("ART_ARROW_G",GetPointX(8),GetPointY(8),0,aRoad8,artefactSpecialAI);

			return Units,50;
		}

		if(bRoad3==false
			&& Distance(uUnit.GetLocationX(),uUnit.GetLocationY(),GetPointX(3),GetPointY(3))<5)
		{
			bRoad3=true;
			RemoveArtefact(GetPointX(3),GetPointY(3),0);

			return Supply,50;
		}

		if(bRoad4==false
			&& Distance(uUnit.GetLocationX(),uUnit.GetLocationY(),GetPointX(4),GetPointY(4))<5)
		{
			bRoad4=true;
			RemoveArtefact(GetPointX(4),GetPointY(4),0);
            return Supply,50;
		}

		if(bRoad5==false
			&& Distance(uUnit.GetLocationX(),uUnit.GetLocationY(),GetPointX(5),GetPointY(5))<6)
		{
			bRoad5=true;
			RemoveArtefact(GetPointX(5),GetPointY(5),0);
			EnableGoal(gSupply,true);
			AddBriefing(SND_T1_BRIEFING_SUPPLY,TRL_T1_BRIEFING_SUPPLY);
            PlayWave("Fanfare.wav",20);
            PlayWave(SND_T1_CON_SUPPLY,40);
			SetConsoleText(1,TRL_T1_CON_SUPPLY);
			SetConsoleText(2,"");
			SetConsoleText(3,"");
			EnableGoal(gSupply,true);
			iUnitAmmo = uUnit.GetAmmo();
			if(iUnitAmmo == uUnit.GetMaxAmmo())
			{//zeby sie nie zakleszczylo jak przyjedzie z pelna amunicj
				iUnitAmmo = iUnitAmmo-1;
			}
            CheckSupplyLive();
			return Supply,50;
		}
		return Supply,50;
	}

	//-----------------------------------------------------------------------------------------
    state Units
    {
		
		if(bRoad6==false
			&& Distance(uUnit.GetLocationX(),uUnit.GetLocationY(),GetPointX(6),GetPointY(6))<4)
		{
			bRoad6=true;
			RemoveArtefact(GetPointX(6),GetPointY(6),0);

			return Units,50;
		}

		if(bRoad7==false
			&& Distance(uUnit.GetLocationX(),uUnit.GetLocationY(),GetPointX(7),GetPointY(7))<4)
		{
			bRoad7=true;
			RemoveArtefact(GetPointX(7),GetPointY(7),0);
			
			return Units,50;
		}

		if(bRoad8==false
			&& Distance(uUnit.GetLocationX(),uUnit.GetLocationY(),GetPointX(8),GetPointY(8))<4)
		{
			bRoad8=true;
			RemoveArtefact(GetPointX(8),GetPointY(8),0);
			bPlatoon = true;

            if(bRoad6==false)RemoveArtefact(GetPointX(6),GetPointY(6),0);
    		if(bRoad7==false)RemoveArtefact(GetPointX(7),GetPointY(7),0);
	

			SetGameRectEx(uUnit,GetPointX(8)-5,GetPointY(9)-8,GetPointX(9)+11,GetPointY(9)+2);

			SetGoalState(gUnits, goalAchieved);
			EnableGoal(gSoldiers,true);

			pPlayer3.GiveAllUnitsTo(pPlayer);
			
			//pPlayer.LookAt(GetPointX(8),GetPointY(8),12,0,9,0);

			AddBriefing(SND_T1_BRIEFING_PLATOON,TRL_T1_BRIEFING_PLATOON);
            PlayWave("Fanfare.wav",20);
            PlayWave(SND_T1_CON_PLATOON,40);
			SetConsoleText(1,TRL_T1_CON_PLATOON);
			SetConsoleText(2,"");
			SetConsoleText(3,"");

			RemoveWorldMapSign(GetPointX(8),GetPointY(8),0);
			AddWorldMapSign(GetPointX(10),GetPointY(10),0,2,65000);

			pEnemy.MakeBombingAttack(GetPointX(37),GetPointY(37),"RUS_BOMBER","RUS_BOMB",16,5,0,0,-1);

			CreateArtefact("ART_ARROW_P",GetPointX(9),GetPointY(9),0,aRoad9,artefactSpecialAI);
			CreateArtefact("ART_ARROW_G",GetPointX(10),GetPointY(10),0,aRoad10,artefactSpecialAI);

            bCheckTiger=false;
			return Soldiers,50;
		}

		return Units,50;
	}

	//-----------------------------------------------------------------------------------------
    state Soldiers
    {
		if(bRoad9==false
            && IsUnitNearPoint(GetPointX(9),GetPointY(9),0,3,pPlayer.GetIFF()))
		{
			bRoad9=true;
			RemoveArtefact(GetPointX(9),GetPointY(9),0);

			return Soldiers,50;
		}

		if(bRoad10==false
			&& IsUnitNearPoint(GetPointX(10),GetPointY(10),0,2,pPlayer.GetIFF()))
		{
			bRoad10=true;
			RemoveArtefact(GetPointX(10),GetPointY(10),0);
            if(bRoad9==false)RemoveArtefact(GetPointX(9),GetPointY(9),0);

			SetGoalState(gSoldiers, goalAchieved);
			EnableGoal(gVillage,true);

			SetGameRect(GetPointX(8)-5,GetPointY(8)-8,GetPointX(13)+12,GetPointY(13)+3);

			AddBriefing(SND_T1_BRIEFING_SOLDIERS,TRL_T1_BRIEFING_SOLDIERS);
            bTimerEnabled=true;
			iTimer=5;

			pPlayer2.GiveAllUnitsTo(pPlayer);
			
			CreateArtefact("ART_ARROW_P",GetPointX(11),GetPointY(11),0,aRoad11,artefactSpecialAI);

			RemoveWorldMapSign(GetPointX(10),GetPointY(10),0);
			AddWorldMapSign(GetPointX(25),GetPointY(25),0,1,65000);

			return Village,50;
		}

		return Soldiers, 50;
	}

	//-----------------------------------------------------------------------------------------
    state Village
    {
		if(GetGoalState(gVillage)!=goalAchieved && 
			!IsUnitNearPoint(GetPointX(25),GetPointY(25),0,4,pEnemy.GetIFF()) &&
			IsUnitNearPoint(GetPointX(25),GetPointY(25),0,4,pPlayer.GetIFF()))
		{
			SetGoalState(gVillage, goalAchieved);
            PlayWave("Fanfare.wav",20);
            PlayWave(SND_T1_CON_VILLAGEEND,40);
			SetConsoleText(1,TRL_T1_CON_VILLAGEEND);
			SetConsoleText(2,TRL_T1_CON_VILLAGEEND2);
			SetConsoleText(3,"");
			bTimerEnabled=true;
			iTimer=5;

			SetGameRect(GetPointX(8)-5,GetPointY(8)-8,GetPointX(15)+14,GetPointY(15)+10);

			RemoveArtefact(GetPointX(25),GetPointY(25),0);
			CreateArtefact("ART_ZNAKGER",GetPointX(25),GetPointY(25),0,aVillage,artefactSpecialAI);

			pPlayer.CreateUnit(GetPointX(41),GetPointY(41),0,"GER_REPAIR");
			uRepair=GetUnit(GetPointX(41),GetPointY(41),0);
			uRepair.CommandMove(GetPointX(25),GetPointY(25),0);

			pEnemy.MakeBombingAttack(GetPointX(38),GetPointY(38),"RUS_BOMBER","RUS_BOMB",16,5,0,0,-1);

			CreateArtefact("ART_ARROW_L",GetPointX(13),GetPointY(13),0,aRoad13,artefactSpecialAI);
			CreateArtefact("ART_ARROW_D",GetPointX(14),GetPointY(14),0,aRoad14,artefactSpecialAI);

			RemoveWorldMapSign(GetPointX(25),GetPointY(25),0);
			AddWorldMapSign(GetPointX(46),GetPointY(46),0,1,-1);

			return Aircraft,160;
		}

		if(bRoad11==false
			&& IsUnitNearPoint(GetPointX(11),GetPointY(11),0,4,pPlayer.GetIFF()))
		{
			bRoad11=true;
			SetGameRect(GetPointX(8)-15,GetPointY(11)-11,GetPointX(11)+11,GetPointY(11)+11);
			RemoveArtefact(GetPointX(11),GetPointY(11),0);
			//pPlayer.LookAt(GetPointX(11),GetPointY(11),12,0,9,0);

			AddBriefing(SND_T1_BRIEFING_VILLAGE,TRL_T1_BRIEFING_VILLAGE);
            
            PlayWave("Fanfare.wav",20);
            PlayWave(SND_T1_CON_VILLAGE,40);
			SetConsoleText(1,TRL_T1_CON_VILLAGE);
			SetConsoleText(2,"");
			SetConsoleText(3,"");
			

			return Village,50;
		}

		return Village,50;
	}

	//-----------------------------------------------------------------------------------------
    state Aircraft
    {
		if(GetGoalState(gAircraft)!=goalAchieved 
			&& !IsUnitNearPoint(GetPointX(15),GetPointY(15),0,12,pEnemy.GetIFF()))
		{
			SetGoalState(gAircraft, goalAchieved);
			EnableGoal(gV2,true);
            PlayWave("Fanfare.wav",20);
            PlayWave(SND_T1_CON_AIRCRAFTEND,40);
			SetConsoleText(1,TRL_T1_CON_AIRCRAFTEND);
			SetConsoleText(2,"");
			SetConsoleText(3,"");
			bTimerEnabled=true;
			iTimer=5;

			SetGameRect(0,0,0,0);
			bCheckBuildings=true;

			RemoveWorldMapSign(GetPointX(46),GetPointY(46),0);
			AddWorldMapSign(GetPointX(39),GetPointY(39),0,1,65000);

			CreateArtefact("ART_ARROW_PD",GetPointX(15),GetPointY(15),0,aRoad15,artefactSpecialAI);
			CreateArtefact("ART_ARROW_PD",GetPointX(16),GetPointY(16),0,aRoad16,artefactSpecialAI);

			return V2,50;
		}

		if(bRoad13==false
			&& IsUnitNearPoint(GetPointX(13),GetPointY(13),0,4,pPlayer.GetIFF()))
		{
			bRoad13=true;
			RemoveArtefact(GetPointX(13),GetPointY(13),0);

			return Aircraft,50;
		}

		if(bRoad14==false
			&& IsUnitNearPoint(GetPointX(14),GetPointY(14),0,4,pPlayer.GetIFF()))
		{
			bRoad14=true;
			RemoveArtefact(GetPointX(14),GetPointY(14),0);
            if(bRoad13==false)RemoveArtefact(GetPointX(13),GetPointY(13),0);

			pPlayer.LookAt(GetPointX(46),GetPointY(46),12,0,9,0);
			AddBriefing(SND_T1_BRIEFING_AIRCRAFT,TRL_T1_BRIEFING_AIRCRAFT);
			EnableGoal(gAircraft,true);

            PlayWave("Fanfare.wav",20);
            PlayWave(SND_T1_CON_AIRCRAFT,40);
			SetConsoleText(1,TRL_T1_CON_AIRCRAFT);
			SetConsoleText(2,"");
			SetConsoleText(3,"");
			bTimerEnabled=true;
			iTimer=5;

			LightBomber = pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 0);
			HeavyBomber = pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 0);
			pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 4);
			//Artillery = pPlayer.AddArtileryOrAirStrike(null,"GER_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,0);

			pPlayer.AddArtileryOrAirStrike(LightBomber, 6);
			pPlayer.AddArtileryOrAirStrike(HeavyBomber, 1);
			//pPlayer.AddArtileryOrAirStrike(Artillery, 1);

			pPlayer.MakeBombingAttack(GetPointX(46),GetPointY(46),"GER_RECON","RECON_GER",0,3,3,0,-1);

			return Aircraft,50;
		}

		return Aircraft,50;
	}

	//-----------------------------------------------------------------------------------------
    state V2
    {
		if(GetGoalState(gV2)!=goalAchieved 
			&& IsUnitNearPoint(GetPointX(39),GetPointY(39),0,9,pPlayer.GetIFF())
			&& !IsUnitNearPoint(GetPointX(39),GetPointY(39),0,9,pEnemy.GetIFF()))
		{
            if(bRoad15==false)RemoveArtefact(GetPointX(15),GetPointY(15),0);
    		if(bRoad16==false)RemoveArtefact(GetPointX(16),GetPointY(16),0);

			SetGoalState(gV2, goalAchieved);
			EnableGoal(gEnemy,true);

			AddBriefing(SND_T1_BRIEFING_NEWPOSITION,TRL_T1_BRIEFING_NEWPOSITION);

            PlayWave("Fanfare.wav",20);
            PlayWave(SND_T1_CON_DESTROYTANKS,40);
			SetConsoleText(1,TRL_T1_CON_DESTROYTANKS);
			SetConsoleText(2,"");
			SetConsoleText(3,"");
			bTimerEnabled=true;
			iTimer=6;

			//pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 3, 4, 40, 0, false, TRL_AIRSTRIKE1, -1, 3);
			//pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 2);
			//pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 5);
			//pPlayer.AddArtileryOrAirStrike(null,"GER_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,3);
			
			pPlayer.AddArtileryOrAirStrike(LightBomber, 3);
			pPlayer.AddArtileryOrAirStrike(HeavyBomber, 2);
			pPlayer.AddArtileryOrAirStrike(Artillery, 4);

			RemoveArtefact(GetPointX(39),GetPointY(39),0);
			CreateArtefact("ART_ZNAKGER",GetPointX(39),GetPointY(39),0,aV2,artefactSpecialAI);

			RemoveWorldMapSign(GetPointX(39),GetPointY(39),0);

			return V2Attack,2500;
		}

		if(bRoad15==false
			&& IsUnitNearPoint(GetPointX(15),GetPointY(15),0,4,pPlayer.GetIFF()))
		{
			bRoad15=true;
			RemoveArtefact(GetPointX(15),GetPointY(15),0);

			return V2,50;
		}

		if(bRoad16==false
			&& IsUnitNearPoint(GetPointX(16),GetPointY(16),0,4,pPlayer.GetIFF()))
		{
			bRoad16=true;
			RemoveArtefact(GetPointX(16),GetPointY(16),0);

			return V2,50;
		}
        
		return V2,50;
	}

	//-----------------------------------------------------------------------------------------
	state V2Attack
	{
			pEnemyPlatoon1.BeginQuickRecord();
			pEnemyPlatoon1.CommandMove(GetPointX(7),GetPointY(7),0);
			pEnemyPlatoon1.CommandMove(GetPointX(6),GetPointY(6),0);
			pEnemyPlatoon1.CommandMove(GetPointX(5),GetPointY(5),0);
			pEnemyPlatoon1.CommandMove(GetPointX(4),GetPointY(4),0);
			pEnemyPlatoon1.CommandMove(GetPointX(3),GetPointY(3),0);
			pEnemyPlatoon1.CommandMove(GetPointX(2),GetPointY(2),0);
			pEnemyPlatoon1.CommandMove(GetPointX(22),GetPointY(22),0);
			pEnemyPlatoon1.CommandMove(GetPointX(21),GetPointY(21),0);
			pEnemyPlatoon1.CommandMove(GetPointX(20),GetPointY(20),0);
			pEnemyPlatoon1.CommandMove(GetPointX(19),GetPointY(19),0);
			pEnemyPlatoon1.CommandMove(GetPointX(39),GetPointY(39),0);
			pEnemyPlatoon1.EndQuickRecord();
			
			pEnemyPlatoon2.BeginQuickRecord();
			pEnemyPlatoon2.CommandMove(GetPointX(9),GetPointY(9),0);
			pEnemyPlatoon2.CommandMove(GetPointX(14),GetPointY(14),0);
			pEnemyPlatoon2.CommandMove(GetPointX(46),GetPointY(46),0);
			pEnemyPlatoon2.CommandMove(GetPointX(39),GetPointY(39),0);
			/*pEnemyPlatoon2.CommandMove(GetPointX(3),GetPointY(3),0);
			pEnemyPlatoon2.CommandMove(GetPointX(2),GetPointY(2),0);
			pEnemyPlatoon2.CommandMove(GetPointX(22),GetPointY(22),0);
			pEnemyPlatoon2.CommandMove(GetPointX(21),GetPointY(21),0);
			pEnemyPlatoon2.CommandMove(GetPointX(20),GetPointY(20),0);
			pEnemyPlatoon2.CommandMove(GetPointX(19),GetPointY(19),0);
			pEnemyPlatoon2.CommandMove(GetPointX(39),GetPointY(39),0);*/
			pEnemyPlatoon2.EndQuickRecord();

			pEnemyPlatoon3.BeginQuickRecord();
			pEnemyPlatoon3.CommandMove(GetPointX(7),GetPointY(7),0);
			pEnemyPlatoon3.CommandMove(GetPointX(6),GetPointY(6),0);
			pEnemyPlatoon3.CommandMove(GetPointX(5),GetPointY(5),0);
			pEnemyPlatoon3.CommandMove(GetPointX(4),GetPointY(4),0);
			pEnemyPlatoon3.CommandMove(GetPointX(3),GetPointY(3),0);
			pEnemyPlatoon3.CommandMove(GetPointX(2),GetPointY(2),0);
			pEnemyPlatoon3.CommandMove(GetPointX(22),GetPointY(22),0);
			pEnemyPlatoon3.CommandMove(GetPointX(21),GetPointY(21),0);
			pEnemyPlatoon3.CommandMove(GetPointX(20),GetPointY(20),0);
			pEnemyPlatoon3.CommandMove(GetPointX(19),GetPointY(19),0);
			pEnemyPlatoon3.CommandMove(GetPointX(39),GetPointY(39),0);
			pEnemyPlatoon3.EndQuickRecord();

			pEnemyPlatoon5.BeginQuickRecord();
			pEnemyPlatoon5.CommandMove(GetPointX(21),GetPointY(21),0);
			pEnemyPlatoon5.CommandMove(GetPointX(20),GetPointY(20),0);
			pEnemyPlatoon5.CommandMove(GetPointX(19),GetPointY(19),0);
			pEnemyPlatoon5.CommandMove(GetPointX(39),GetPointY(39),0);
			pEnemyPlatoon5.EndQuickRecord();

			pEnemyPlatoon6.BeginQuickRecord();
			pEnemyPlatoon6.CommandMove(GetPointX(21),GetPointY(21),0);
			pEnemyPlatoon6.CommandMove(GetPointX(20),GetPointY(20),0);
			pEnemyPlatoon6.CommandMove(GetPointX(19),GetPointY(19),0);
			pEnemyPlatoon6.CommandMove(GetPointX(39),GetPointY(39),0);
			pEnemyPlatoon6.EndQuickRecord();

			return EndMission,50;
	}

    state EndMission
    {	
		// End Mission ---------------------------------------------------------------------
		if(	pEnemyPlatoon1.GetUnitsCount()==0 &&
			pEnemyPlatoon2.GetUnitsCount()==0 &&
			pEnemyPlatoon3.GetUnitsCount()==0 &&
			pEnemyPlatoon5.GetUnitsCount()==0 &&
			pEnemyPlatoon6.GetUnitsCount()==0)
		{
			SetGoalState(gEnemy, goalAchieved);

			AddBriefing(SND_T1_BRIEFING_VICTORY,TRL_T1_BRIEFING_VICTORY);
			
			EndMission(true);
		
			return Nothing,500;
		}

		return EndMission,50;
	}

	//
	state MissionFailed
	{
		AddBriefing(SND_T1_BRIEFING_FAIL, TRL_T1_BRIEFING_FAIL);
        //AddBriefing(null, TRL_T1_BRIEFING_FAIL);
		//TraceD("MissionFailed                     \n");
		EndMission(false);

		return Nothing,200;
	}

	//
	state MissionFailed2
	{
		AddBriefing(SND_T1_BRIEFING_HERO_DEAD, TRL_T1_BRIEFING_HERO_DEAD);
        //AddBriefing(null, TRL_T1_BRIEFING_HERO_DEAD);
		//TraceD("MissionFailed2                     \n");
		EndMission(false);

		return Nothing,200;
	}

	//-----------------------------------------------------------------------------------------
    state Nothing
    {
        return Nothing,500;
    }

	//-----------------------------------------------------------------------------------------
	event Timer0()
	{
		if(bTimerEnabled)
		{
			iTimer=iTimer-1;
			if(iTimer==0)
			{
				//SetConsoleText(1,"");
				bTimerEnabled=false;
			}
		}
	}

	//-----------------------------------------------------------------------------------------
	event Timer2()
    {
        CheckSupplyLive();
    }
    event Timer1()
	{
		if (!CheckUnitsCount())
		{
			state MissionFailed;
		}
        
        if(iSupplyDestroyed==2)
        {
			state MissionFailed;
		}
        
		if (!CheckTigerLive())
		{
			state MissionFailed2;
		}

	}

	//----------------------------------------------------------------------------------------- 
	event UnitDestroyed(unit uUnit, player pKilledByPlayer)
	{
		//if(pKilledByPlayer!=null && uUnit.IsUpdate("GER_REPAIR")) --iUnitNotArmor;
	}
	event BuildingDestroyed(unit uUnit, player pKilledByPlayer)
	{

        if(uUnit.GetBuildingType() == buildingSupplyCenter &&
            uSupplyBuilding!=uUnit)
        {
            uSupplyBuilding = uUnit;
            iSupplyDestroyed = iSupplyDestroyed+1;
            TraceD("                               Destroyed supply center =");
            TraceD(iSupplyDestroyed);
            TraceD("                               \n");
        }

        if(!bCheckBuildings)
        if(uUnit.GetIFF()==pPlayer.GetIFF() && pKilledByPlayer==pPlayer)
        {
            state MissionFailed;
        }
		//if(pKilledByPlayer!=null && uUnit.IsUpdate("GER_REPAIR")) --iUnitNotArmor;
	}

	//-----------------------------------------------------------------------------------------
    command Uninitialize()
    {
        pEnemyPlatoon1=null;
        pEnemyPlatoon2=null;
        pEnemyPlatoon3=null;
		pEnemyPlatoon4=null;
        pEnemyPlatoon5=null;
		pEnemyPlatoon6=null;

		return true;
    }
}
