#include "..\..\Translates.ech"

mission TRL_R23_SCRIPTNAME
{
#define USE_TRACE
#include "..\..\Trace.ech"
#include "..\..\Common.ech"

//Declarations

state Initialize;
state ShowStartBriefing;
state RescueRecon;
state AttackHills;
state DestroyTruck;
state Victory;
state MissionFailed;
state MissionFailed2;
state MissionFailed3;
state MissionFailed4;

player m_pPlayer;
player m_pPlayer2;
player m_pEnemy;

platoon m_pPlayer2Recon;
platoon m_pEnemyTruck;

platoon m_pEnemyHillAttack1;
platoon m_pEnemyHillAttack2;
platoon m_pEnemyHillAttack3;

platoon m_pEnemyFinalHillAttack1;
platoon m_pEnemyFinalHillAttack2;
platoon m_pEnemyFinalHillAttack3;
platoon m_pEnemyFinalHillAttack4;
platoon m_pEnemyFinalHillAttack5;
platoon m_pEnemyFinalHillAttack6;
platoon m_pEnemyFinalHillAttack7;
platoon m_pEnemyFinalHillAttack8;

human m_hHero;
unitex uSupply;
unitex uHero;
int m_bInformationHeroRadio;
int m_bRescueRecon;
int m_bAttackHills;

int m_bDefenceposition1;
//int m_bDefenceposition2;
//int m_bDefenceposition3;
//int m_bDefenceposition4;

int EnemyPosition1;
int EnemyPosition2;
int EnemyPosition3;
int EnemyPosition4;
int EnemyPosition5;

int m_bTimerSetConsole;
int m_nTimerSetConsole;

int m_nAirStrikeID;
int m_nAirStrikeID2;
int m_nAirStrikeID3;
int iArtillery;

int bMapSign1;
int bMapSign2;
int bMapSign3;
int iMapSign1;
int iMapSign2;
int iMapSign3;

consts
{
    //Artefact
	aPlayerPositionRUS1 = 0;
	aPlayerPositionRUS2 = 1;
	aPlayerPositionRUS3 = 2;
	aPlayerPositionRUS4 = 3;
	aEnemyPositionGER1 = 4;
	aEnemyPositionGER2 = 5;
	aEnemyPositionGER3 = 6;
	aEnemyPositionGER4 = 7;
	aEnemyPositionGER5 = 8;

	aEnemyPositionRUS1 = 9;
	aEnemyPositionRUS2 = 10;
	aEnemyPositionRUS3 = 11;
	aEnemyPositionRUS4 = 12;
	aEnemyPositionRUS5 = 13;
    //aNazwa
    //Goals
    gRescuePlatoon = 0;
    gAttackHills = 1;
 //   gDestroyTruck = 2;
    gDefenceStartPosition = 2;
//    gHeroLive = 4;
}


//Functions
//Usunicie obiektw z markerw
function void RemoveObjects(int nMarkerFrom, int nMarkerTo)
{
    int nMarker;
    
    for (nMarker = nMarkerFrom; nMarker <= nMarkerTo; ++nMarker)
    {
		ClearArea(15,GetPointX(nMarker),GetPointY(nMarker),0,0);
    }
}//|

function int CheckHeroLive()
{
    if (!m_hHero.IsLive())
    {
        AddBriefing(SND_R23_BRIEFING_HERO_DEAD, TRL_R23_BRIEFING_HERO_DEAD);
        EndMission(false);

        return false;
    }

    return true;
}

function int CheckUnitsCount()
{
    if (m_pPlayer.GetNumberOfUnits()==1 && uSupply.IsLive())

    { 
		AddBriefing(SND_R23_BRIEFING_HERO_DEAD, TRL_R23_BRIEFING_HERO_DEAD);
        EndMission(false);
        return false;
    }
    return true;
}

function int CheckSupplyLive()
{
    if (uSupply==null || !uSupply.IsLive())
    {
		uSupply = m_pPlayer.CreateUnit(GetPointX(55), GetPointY(55), 0, "RUS_SUPL1");
		if(uSupply!=null)
		{
			uSupply.CommandMove(GetPointX(56), GetPointY(56), 0);
			AddWorldMapSign(GetPointX(55), GetPointY(55), 0, 2, 200);
		}
		}
    return true;

}//|

//wydaje komendy ruchu od markera nMarkerFrom do nMarkerTo (w calym zakresie)
function void MovePlatoon(platoon pPlatoon, int nMarkerFrom, int nMarkerTo)
{
    int nMarker;
    
    for (nMarker = nMarkerFrom; nMarker <= nMarkerTo; ++nMarker)
    {
        pPlatoon.CommandMove(GetPointX(nMarker), GetPointY(nMarker), 0);
    }
}//|

//States
//pierwszy state po uruchomieniu
state Initialize
{
    //---------- Players --------------------------
    m_pPlayer = GetPlayer(0); 
    m_pEnemy = GetPlayer(1);
    m_pPlayer2 = GetPlayer(2); 

    //---------- AI -------------------------------
	m_pPlayer.EnableStatistics(true);
	m_pEnemy.EnableStatistics(true);
	m_pPlayer2.EnableStatistics(false);

	//m_pPlayer.EnableAIFeatures(aiEnabled,false);
	m_pPlayer2.EnableAIFeatures(aiEnabled,false);
    m_pPlayer2.EnableAIFeatures2(ai2ChooseEnemy, false);
	m_pEnemy.EnableAIFeatures(aiEnabled,false);
     m_pEnemy.EnableAIFeatures2(ai2ChooseEnemy, false);

	m_pPlayer2.EnableAIFeatures(aiControlOffense,false);
	m_pPlayer2.EnableAIFeatures(aiRejectAlliance,false);
// ustawienie neutralnoci playera przy blokowaniu unitw
	//m_pPlayer2.SetNeutral(m_pEnemy);
	//m_pEnemy.SetNeutral(m_pPlayer2);
	//m_pPlayer2.SetEnemy(m_pEnemy);
	m_pEnemy.SetEnemy(m_pPlayer2);

	m_pPlayer2.SetEnemy(m_pEnemy);
	m_pPlayer2.SetNeutral(m_pPlayer);
    m_pPlayer.SetNeutral(m_pPlayer2);


	m_pPlayer.SetAlly(m_pPlayer2);
    //----------- Units --------------------------- 
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(41), GetPointY(41), 0);
    uHero = GetUnit(GetPointX(41), GetPointY(41), 0); // (marker())
    m_hHero = uHero.GetHuman(0);
    m_hHero.SetHumanName(TRL_RUSHERO7_NAME);
    m_hHero.SetIsSpecialHuman(true);
	uSupply = GetUnit(GetPointX(55), GetPointY(55), 0);
   //----------- Platoon -------------------------
    //----------- Create Artefactr ----------------
    CreateArtefact("ART_ZNAKRUS", GetPointX(30), GetPointY(30), 0, aPlayerPositionRUS1, artefactSpecialAI);
	CreateArtefact("ART_ZNAKRUS", GetPointX(31), GetPointY(31), 0, aPlayerPositionRUS2, artefactSpecialAI);
    CreateArtefact("ART_ZNAKRUS", GetPointX(32), GetPointY(32), 0, aPlayerPositionRUS3, artefactSpecialAI);
	CreateArtefact("ART_ZNAKRUS", GetPointX(33), GetPointY(33), 0, aPlayerPositionRUS4, artefactSpecialAI);
    CreateArtefact("ART_ZNAKGER", GetPointX(34), GetPointY(34), 0, aEnemyPositionGER1, artefactSpecialAI);
	CreateArtefact("ART_ZNAKGER", GetPointX(35), GetPointY(35), 0, aEnemyPositionGER2, artefactSpecialAI);
    CreateArtefact("ART_ZNAKGER", GetPointX(36), GetPointY(36), 0, aEnemyPositionGER3, artefactSpecialAI);
	CreateArtefact("ART_ZNAKGER", GetPointX(37), GetPointY(37), 0, aEnemyPositionGER4, artefactSpecialAI);
	CreateArtefact("ART_ZNAKGER", GetPointX(38), GetPointY(38), 0, aEnemyPositionGER5, artefactSpecialAI);
    //----------- Register Goal -------------------
    RegisterGoal(gRescuePlatoon, TRL_R23_GOAL_RESCUEPLATOON);
    RegisterGoal(gAttackHills, TRL_R23_GOAL_ATTACKHILLS);
    //RegisterGoal(gDestroyTruck, TRL_R23_GOAL_DESTROYTRUCK);
    RegisterGoal(gDefenceStartPosition, TRL_R23_GOAL_DEFENCESTARTPOSITION);
    //RegisterGoal(gHeroLive, TRL_R23_GOAL_HEROLIVE);
    //----------- Artilery or AirStrike -----------
    if (GetDifficultyLevel() == 0)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_LBOMBER", "RUS_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 7);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_HBOMBER", "RUS_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 9);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("RUS_RECON", "RECON_RUS", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 6);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"RUS_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,4);
 
		m_pEnemy.CreateBuilding( 137,  140, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 81,  141, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 159,  111, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 83,  29, 0, 128, "GER_DEFPLOT");		
	}
    else if (GetDifficultyLevel() == 1)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_LBOMBER", "RUS_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 6);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_HBOMBER", "RUS_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 8);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("RUS_RECON", "RECON_RUS", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 5);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"RUS_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,3);

		m_pEnemy.CreateBuilding( 137,  140, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 81,  141, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 51,  93, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 159,  111, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 94,  128, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 154,  44, 0, 128, "GER_DEFPLOT");

        RemoveObjects(184,186);
	}
    else if (GetDifficultyLevel() == 2)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_LBOMBER", "RUS_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 5);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_HBOMBER", "RUS_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 7);        
		m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("RUS_RECON", "RECON_RUS", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 4);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"RUS_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,2);

		m_pEnemy.CreateBuilding( 137,  140, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 81,  141, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 51,  93, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 159,  111, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 151,  102, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 93,  93, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 115,  61, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 94,  128, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 83,  29, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 154,  44, 0, 128, "GER_DEFPLOT");

        RemoveObjects(184,186);
	}



    SetupDifficultyLevel(m_pEnemy);

    //----------- Object Template -----------------

    //----------- Enable Command -----------------
    // Budynki nie maj autodestrukcji
    m_pPlayer.EnableCommand(commandAutodestruction, false);  

    //----------- Time ----------------------------
    //Ustawienie czasu w grze
    SetTime(64);

    //----------- Timer ---------------------------
    SetTimer(0, 50);     // 2.5 s
    SetTimer(1, 50);     // 2.5 s
    SetTimer(2, 1200);     // 1 min
    //----------- Console Text --------------------
    // Zdefionowanie ile linijek bdzie do wywietlania console_textw liczonych od gry
    AddConsoleTextDisplay(0, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(1, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(2, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(3, 0, 100, SS_CENTER);

    //----------- Camera --------------------------
    // Przywoanie kamery i ustawienie jest nad starting pointem
    CallCamera();
    m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 7, 0, 30, 0);

	SelectBuildPanelTab(4);

    //----------- Variables -----------------------
    m_bTimerSetConsole = false;
    m_nTimerSetConsole = 0;
	m_bInformationHeroRadio = false;
	m_bRescueRecon = false;
	m_bAttackHills = false;
	EnemyPosition1 = false;
	EnemyPosition2 = false;
	EnemyPosition3 = false;
	EnemyPosition4 = false;
	EnemyPosition5 = false;
	m_bDefenceposition1 = false;
	//m_bDefenceposition2 = false;
	//m_bDefenceposition3 = false;
	//m_bDefenceposition4 = false;

    return ShowStartBriefing, 50; // Przejcie do state ShowStartBriefing za 2.5 sekundy
}//|
state ShowStartBriefing
{
    EnableGoal(gRescuePlatoon, true);
    EnableGoal(gAttackHills, true);
    //EnableGoal(gDestroyTruck, true);
    EnableGoal(gDefenceStartPosition, true);
    //EnableGoal(gHeroLive, true); 

    AddWorldMapSign(GetPointX(0), GetPointY(0), 0, 9, 100);

		m_pPlayer2.CreateUnit(GetPointX(0) + 0, GetPointY(0) + 0, 0, "RUS_T34");
        m_pPlayer2.CreateUnit(GetPointX(0) + 1, GetPointY(0) + 0, 0, "RUS_T34");
        m_pPlayer2.CreateUnit(GetPointX(0) - 1, GetPointY(0) + 0, 0, "RUS_SOLDIERSQUAD");
        m_pPlayer2.CreateUnit(GetPointX(0) + 0, GetPointY(0) + 1, 0, "RUS_BA20");
        m_pPlayer2.CreateUnit(GetPointX(0) + 1, GetPointY(0) + 1, 0, "RUS_BA20");

       m_pPlayer2Recon = m_pPlayer2.CreatePlatoon(null, GetPointX(39), GetPointY(39), GetPointX(21), GetPointY(21), 0);
        //trasa przejazdu plutonu 
        m_pPlayer2Recon.BeginQuickRecord();
        MovePlatoon(m_pPlayer2Recon, 1, 16);//zakres poruszania plutonu po markerach
        m_pPlayer2Recon.EndQuickRecord();

    AddBriefing(SND_R23_BRIEFING_START, TRL_R23_BRIEFING_START);

    return RescueRecon, 200; //200 odstep po briefingu
}//|

state RescueRecon
{
    if (!m_bRescueRecon
        && IsUnitNearPoint(GetPointX(16), GetPointY(16), 0, 5, m_pPlayer2.GetIFF()))
	{
        m_bRescueRecon = true;//dac info o wzgorzach i radiu w m 40 dla hero
       	PlayWave("Fanfare.wav");
		PlayWave(SND_R23_CON_RESCUERECON_1,20);
		SetConsoleText(1, TRL_R23_CON_RESCUERECON_1);

        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;

		SetGoalState(gRescuePlatoon,goalAchieved);
		m_pPlayer2.GiveAllUnitsTo(m_pPlayer);


		AddWorldMapSign(GetPointX(20), GetPointY(20), 0, 1, -1);

		return AttackHills, 50;
	}

	if (m_pPlayer2Recon.GetUnitsCount()==0) return MissionFailed4,50;

    return RescueRecon, 50;
}//|

state AttackHills
{
    if (!m_bAttackHills &&
        !IsUnitNearPoint(GetPointX(20), GetPointY(20), 0, 10, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(20), GetPointY(20), 0, 4, m_pPlayer.GetIFF()))
	{
        m_bAttackHills = true;
       	PlayWave("Fanfare.wav");
		PlayWave(SND_R23_CON_ATTACKHILLS_1,20);
        SetConsoleText(1, TRL_R23_CON_ATTACKHILLS_1);
        SetConsoleText(2, TRL_R23_CON_ATTACKHILLS_2);
        SetConsoleText(3, TRL_R23_CON_ATTACKHILLS_3);
        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;

		SetGoalState(gAttackHills,goalAchieved);

        RemoveWorldMapSign(GetPointX(20), GetPointY(20), 0);

		AddWorldMapSign(GetPointX(30), GetPointY(30), 0, 0, 65000);
		AddWorldMapSign(GetPointX(31), GetPointY(31), 0, 0, 65000);
		AddWorldMapSign(GetPointX(32), GetPointY(32), 0, 0, 65000);
		AddWorldMapSign(GetPointX(33), GetPointY(33), 0, 0, 65000);
		//AddWorldMapSign(GetPointX(20), GetPointY(20), 0, 0, 65000);

										/*m_pEnemy.CreateUnit(GetPointX(0) + 0, GetPointY(0) + 0, 0, "GER_OPEL");
										m_pEnemy.CreateUnit(GetPointX(0) + 1, GetPointY(0) + 0, 0, "GER_OPEL");
										m_pEnemy.CreateUnit(GetPointX(0) - 1, GetPointY(0) + 0, 0, "GER_OPEL");
										m_pEnemy.CreateUnit(GetPointX(0) + 0, GetPointY(0) + 1, 0, "GER_OPEL");
    
										//skladam z nich pluton pomiedzy m 11 i m 12
										m_pEnemyTruck = m_pEnemy.CreatePlatoon(null, GetPointX(21), GetPointY(21), GetPointX(39), GetPointY(39), 0);
										//trasa przejazdu plutonu wroga
										m_pEnemyTruck.BeginQuickRecord();
										MovePlatoon(m_pEnemyTruck, 21, 29);//zakres poruszania plutonu po markerach
										m_pEnemyTruck.CommandMove(GetPointX(17), GetPointY(17), 0);
										m_pEnemyTruck.EndQuickRecord();*/

        m_pEnemy.CreateUnit(GetPointX(42) + 0, GetPointY(42) + 0, 0, "GER_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(42) + 1, GetPointY(42) + 0, 0, "GER_PANZER4H");
        m_pEnemy.CreateUnit(GetPointX(42) - 1, GetPointY(42) + 0, 0, "GER_STURMSQUAD");
        m_pEnemy.CreateUnit(GetPointX(42) + 0, GetPointY(42) + 1, 0, "GER_STURMSQUAD");
        m_pEnemy.CreateUnit(GetPointX(42) + 1, GetPointY(42) + 1, 0, "GER_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(42) - 1, GetPointY(42) + 1, 0, "GER_STUG4");
        m_pEnemy.CreateUnit(GetPointX(42) + 0, GetPointY(42) - 1, 0, "GER_STUG4");
        m_pEnemy.CreateUnit(GetPointX(42) - 1, GetPointY(42) - 1, 0, "GER_PUMA");
		m_pEnemyHillAttack1 = m_pEnemy.CreatePlatoon(null, GetPointX(43), GetPointY(43), GetPointX(44), GetPointY(44), 0);
		m_pEnemyHillAttack1.BeginQuickRecord();
		MovePlatoon(m_pEnemyHillAttack1, 45, 53);
		m_pEnemyHillAttack1.EndQuickRecord();

        m_pEnemy.CreateUnit(GetPointX(57) + 0, GetPointY(57) + 0, 0, "GER_PANZER4H");
        m_pEnemy.CreateUnit(GetPointX(57) + 1, GetPointY(57) + 0, 0, "GER_PANTHER");
        m_pEnemy.CreateUnit(GetPointX(57) - 1, GetPointY(57) + 0, 0, "GER_STURMSQUAD");
        m_pEnemy.CreateUnit(GetPointX(57) + 0, GetPointY(57) + 1, 0, "GER_STURMSQUAD");
        m_pEnemy.CreateUnit(GetPointX(57) + 1, GetPointY(57) + 1, 0, "GER_TIGER");
        m_pEnemy.CreateUnit(GetPointX(57) - 1, GetPointY(57) + 1, 0, "GER_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(57) + 0, GetPointY(57) - 1, 0, "GER_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(57) - 1, GetPointY(57) - 1, 0, "GER_PUMA");
		m_pEnemyHillAttack2 = m_pEnemy.CreatePlatoon(null, GetPointX(58), GetPointY(58), GetPointX(59), GetPointY(59), 0);
		m_pEnemyHillAttack2.BeginQuickRecord();
		MovePlatoon(m_pEnemyHillAttack2, 60, 65);
		m_pEnemyHillAttack2.EndQuickRecord();

        m_pEnemy.CreateUnit(GetPointX(66) + 0, GetPointY(66) + 0, 0, "GER_PANZER4H");
        m_pEnemy.CreateUnit(GetPointX(66) + 1, GetPointY(66) + 0, 0, "GER_D1DA");
        m_pEnemy.CreateUnit(GetPointX(66) - 1, GetPointY(66) + 0, 0, "GER_STURMSQUAD");
        m_pEnemy.CreateUnit(GetPointX(66) + 0, GetPointY(66) + 1, 0, "GER_STURMSQUAD");
        m_pEnemy.CreateUnit(GetPointX(66) + 1, GetPointY(66) + 1, 0, "GER_D1DA");
        m_pEnemy.CreateUnit(GetPointX(66) - 1, GetPointY(66) + 1, 0, "GER_STUG4");
        m_pEnemy.CreateUnit(GetPointX(66) + 0, GetPointY(66) - 1, 0, "GER_PANTHER");
        m_pEnemy.CreateUnit(GetPointX(66) - 1, GetPointY(66) - 1, 0, "GER_PUMA");
		m_pEnemyHillAttack3 = m_pEnemy.CreatePlatoon(null, GetPointX(67), GetPointY(67), GetPointX(68), GetPointY(68), 0);
		m_pEnemyHillAttack3.BeginQuickRecord();
		MovePlatoon(m_pEnemyHillAttack3, 69, 70);
		m_pEnemyHillAttack3.EndQuickRecord();

        m_pEnemy.CreateUnit(GetPointX(71) + 0, GetPointY(71) + 0, 0, "GER_TIGER");
        m_pEnemy.CreateUnit(GetPointX(71) + 1, GetPointY(71) + 0, 0, "GER_TIGER");
        m_pEnemy.CreateUnit(GetPointX(71) - 1, GetPointY(71) + 0, 0, "GER_PANZER4H");
        m_pEnemy.CreateUnit(GetPointX(71) + 0, GetPointY(71) + 1, 0, "GER_PUMA");
        m_pEnemy.CreateUnit(GetPointX(71) + 1, GetPointY(71) + 1, 0, "GER_PANTHER");
        m_pEnemy.CreateUnit(GetPointX(71) - 1, GetPointY(71) + 1, 0, "GER_STUG4");
        m_pEnemy.CreateUnit(GetPointX(71) + 0, GetPointY(71) - 1, 0, "GER_STUG4");
        m_pEnemy.CreateUnit(GetPointX(71) - 1, GetPointY(71) - 1, 0, "GER_PUMA");
		m_pEnemyFinalHillAttack1 = m_pEnemy.CreatePlatoon(null, GetPointX(72), GetPointY(72), GetPointX(73), GetPointY(73), 0);
		m_pEnemyFinalHillAttack1.BeginQuickRecord();
		MovePlatoon(m_pEnemyFinalHillAttack1, 74, 77);
		m_pEnemyFinalHillAttack1.EndQuickRecord();

        m_pEnemy.CreateUnit(GetPointX(78) + 0, GetPointY(78) + 0, 0, "GER_PANZER4H");
        m_pEnemy.CreateUnit(GetPointX(78) + 1, GetPointY(78) + 0, 0, "GER_PANTHER");
        m_pEnemy.CreateUnit(GetPointX(78) - 1, GetPointY(78) + 0, 0, "GER_STURMSQUAD");
        m_pEnemy.CreateUnit(GetPointX(78) + 0, GetPointY(78) + 1, 0, "GER_STURMSQUAD");
        m_pEnemy.CreateUnit(GetPointX(78) + 1, GetPointY(78) + 1, 0, "GER_PANTHER");
        m_pEnemy.CreateUnit(GetPointX(78) - 1, GetPointY(78) + 1, 0, "GER_PANTHER");
        m_pEnemy.CreateUnit(GetPointX(78) + 0, GetPointY(78) - 1, 0, "GER_STUG4");
        m_pEnemy.CreateUnit(GetPointX(78) - 1, GetPointY(78) - 1, 0, "GER_SDKFZ222");
		m_pEnemyFinalHillAttack2 = m_pEnemy.CreatePlatoon(null, GetPointX(79), GetPointY(79), GetPointX(80), GetPointY(80), 0);
		m_pEnemyFinalHillAttack2.BeginQuickRecord();
		MovePlatoon(m_pEnemyFinalHillAttack2, 81, 90);
		m_pEnemyFinalHillAttack2.EndQuickRecord();

        m_pEnemy.CreateUnit(GetPointX(91) + 0, GetPointY(91) + 0, 0, "GER_SDKFZ222");
        m_pEnemy.CreateUnit(GetPointX(91) + 1, GetPointY(91) + 0, 0, "GER_MARDER3");
        m_pEnemy.CreateUnit(GetPointX(91) - 1, GetPointY(91) + 0, 0, "GER_PANTHER");
        m_pEnemy.CreateUnit(GetPointX(91) + 0, GetPointY(91) + 1, 0, "GER_MARDER3");
        m_pEnemy.CreateUnit(GetPointX(91) + 1, GetPointY(91) + 1, 0, "GER_TIGER");
        m_pEnemy.CreateUnit(GetPointX(91) - 1, GetPointY(91) + 1, 0, "GER_PANTHER");
        m_pEnemy.CreateUnit(GetPointX(91) + 0, GetPointY(91) - 1, 0, "GER_MARDER3");
        m_pEnemy.CreateUnit(GetPointX(91) - 1, GetPointY(91) - 1, 0, "GER_PUMA");
		m_pEnemyFinalHillAttack3 = m_pEnemy.CreatePlatoon(null, GetPointX(92), GetPointY(92), GetPointX(93), GetPointY(93), 0);
		m_pEnemyFinalHillAttack3.BeginQuickRecord();
		MovePlatoon(m_pEnemyFinalHillAttack3, 94, 103);
		m_pEnemyFinalHillAttack3.EndQuickRecord();

        m_pEnemy.CreateUnit(GetPointX(104) + 0, GetPointY(104) + 0, 0, "GER_PANZER4H");
        m_pEnemy.CreateUnit(GetPointX(104) + 1, GetPointY(104) + 0, 0, "GER_STUG3");
        m_pEnemy.CreateUnit(GetPointX(104) - 1, GetPointY(104) + 0, 0, "GER_STURMSQUAD");
        m_pEnemy.CreateUnit(GetPointX(104) + 0, GetPointY(104) + 1, 0, "GER_STURMSQUAD");
        m_pEnemy.CreateUnit(GetPointX(104) + 1, GetPointY(104) + 1, 0, "GER_PANTHER");
        m_pEnemy.CreateUnit(GetPointX(104) - 1, GetPointY(104) + 1, 0, "GER_STUG3");
        m_pEnemy.CreateUnit(GetPointX(104) + 0, GetPointY(104) - 1, 0, "GER_STUG4");
        m_pEnemy.CreateUnit(GetPointX(104) - 1, GetPointY(104) - 1, 0, "GER_PUMA");
		m_pEnemyFinalHillAttack4 = m_pEnemy.CreatePlatoon(null, GetPointX(105), GetPointY(105), GetPointX(106), GetPointY(106), 0);
		m_pEnemyFinalHillAttack4.BeginQuickRecord();
		MovePlatoon(m_pEnemyFinalHillAttack4, 107, 121);
		m_pEnemyFinalHillAttack4.EndQuickRecord();

        m_pEnemy.CreateUnit(GetPointX(122) + 0, GetPointY(122) + 0, 0, "GER_PANZER4H");
        m_pEnemy.CreateUnit(GetPointX(122) + 1, GetPointY(122) + 0, 0, "GER_PANZER4H");
        m_pEnemy.CreateUnit(GetPointX(122) - 1, GetPointY(122) + 0, 0, "GER_STURMSQUAD");
        m_pEnemy.CreateUnit(GetPointX(122) + 0, GetPointY(122) + 1, 0, "GER_RAKAA");
        m_pEnemy.CreateUnit(GetPointX(122) + 1, GetPointY(122) + 1, 0, "GER_TIGER");
        m_pEnemy.CreateUnit(GetPointX(122) - 1, GetPointY(122) + 1, 0, "GER_STUG4");
        m_pEnemy.CreateUnit(GetPointX(122) + 0, GetPointY(122) - 1, 0, "GER_STUG4");
        m_pEnemy.CreateUnit(GetPointX(122) - 1, GetPointY(122) - 1, 0, "GER_TIGER");
		m_pEnemyFinalHillAttack5 = m_pEnemy.CreatePlatoon(null, GetPointX(123), GetPointY(123), GetPointX(124), GetPointY(124), 0);
		m_pEnemyFinalHillAttack5.BeginQuickRecord();
		MovePlatoon(m_pEnemyFinalHillAttack5, 125, 135);
		m_pEnemyFinalHillAttack5.EndQuickRecord();

        m_pEnemy.CreateUnit(GetPointX(136) + 0, GetPointY(136) + 0, 0, "GER_RAKAA");
        m_pEnemy.CreateUnit(GetPointX(136) + 1, GetPointY(136) + 0, 0, "GER_PANZER4H");
        m_pEnemy.CreateUnit(GetPointX(136) - 1, GetPointY(136) + 0, 0, "GER_STURMSQUAD");
        m_pEnemy.CreateUnit(GetPointX(136) + 0, GetPointY(136) + 1, 0, "GER_MARDER3");
        m_pEnemy.CreateUnit(GetPointX(136) + 1, GetPointY(136) + 1, 0, "GER_GRENADESQUAD");
        m_pEnemy.CreateUnit(GetPointX(136) - 1, GetPointY(136) + 1, 0, "GER_RAKAA");
        m_pEnemy.CreateUnit(GetPointX(136) + 0, GetPointY(136) - 1, 0, "GER_STUG4");
        m_pEnemy.CreateUnit(GetPointX(136) - 1, GetPointY(136) - 1, 0, "GER_PUMA");
		m_pEnemyFinalHillAttack6 = m_pEnemy.CreatePlatoon(null, GetPointX(137), GetPointY(137), GetPointX(138), GetPointY(138), 0);
		m_pEnemyFinalHillAttack6.BeginQuickRecord();
		MovePlatoon(m_pEnemyFinalHillAttack6, 139, 152);
		m_pEnemyFinalHillAttack6.EndQuickRecord();

        m_pEnemy.CreateUnit(GetPointX(153) + 0, GetPointY(153) + 0, 0, "GER_PANZER4H");
        m_pEnemy.CreateUnit(GetPointX(153) + 1, GetPointY(153) + 0, 0, "GER_MARDER3");
        m_pEnemy.CreateUnit(GetPointX(153) - 1, GetPointY(153) + 0, 0, "GER_STURMSQUAD");
        m_pEnemy.CreateUnit(GetPointX(153) + 0, GetPointY(153) + 1, 0, "GER_RAKAA");
        m_pEnemy.CreateUnit(GetPointX(153) + 1, GetPointY(153) + 1, 0, "GER_MARDER3");
        m_pEnemy.CreateUnit(GetPointX(153) - 1, GetPointY(153) + 1, 0, "GER_GRENADESQUAD");
        m_pEnemy.CreateUnit(GetPointX(153) + 0, GetPointY(153) - 1, 0, "GER_GRENADESQUAD");
        m_pEnemy.CreateUnit(GetPointX(153) - 1, GetPointY(153) - 1, 0, "GER_MARDER3");
		m_pEnemyFinalHillAttack7 = m_pEnemy.CreatePlatoon(null, GetPointX(154), GetPointY(154), GetPointX(155), GetPointY(155), 0);
		m_pEnemyFinalHillAttack7.BeginQuickRecord();
		MovePlatoon(m_pEnemyFinalHillAttack7, 156, 171);
		m_pEnemyFinalHillAttack7.EndQuickRecord();

        m_pEnemy.CreateUnit(GetPointX(172) + 0, GetPointY(172) + 0, 0, "GER_FERDINAND");
        m_pEnemy.CreateUnit(GetPointX(172) + 1, GetPointY(172) + 0, 0, "GER_PANZER4H");
        m_pEnemy.CreateUnit(GetPointX(172) - 1, GetPointY(172) + 0, 0, "GER_STURMSQUAD");
        m_pEnemy.CreateUnit(GetPointX(172) + 0, GetPointY(172) + 1, 0, "GER_PANTHER");
        m_pEnemy.CreateUnit(GetPointX(172) + 1, GetPointY(172) + 1, 0, "GER_TIGER");
        m_pEnemy.CreateUnit(GetPointX(172) - 1, GetPointY(172) + 1, 0, "GER_STUG4");
        m_pEnemy.CreateUnit(GetPointX(172) + 0, GetPointY(172) - 1, 0, "GER_PANZER4H");
        m_pEnemy.CreateUnit(GetPointX(172) - 1, GetPointY(172) - 1, 0, "GER_PANZER4H");
		m_pEnemyFinalHillAttack8 = m_pEnemy.CreatePlatoon(null, GetPointX(173), GetPointY(173), GetPointX(174), GetPointY(174), 0);
		m_pEnemyFinalHillAttack8.BeginQuickRecord();
		MovePlatoon(m_pEnemyFinalHillAttack8, 175, 183);
		m_pEnemyFinalHillAttack8.EndQuickRecord();

		m_bDefenceposition1 = true;

		return DestroyTruck;
	}
	return AttackHills;

}//|

state DestroyTruck
{

	if (m_pEnemyFinalHillAttack1.GetUnitsCount()==0 
		&&
		m_pEnemyFinalHillAttack2.GetUnitsCount()==0
		&&
		m_pEnemyFinalHillAttack3.GetUnitsCount()==0 
		&&
		m_pEnemyFinalHillAttack4.GetUnitsCount()==0
		&&
		m_pEnemyFinalHillAttack5.GetUnitsCount()==0
		&&
		m_pEnemyFinalHillAttack6.GetUnitsCount()==0
		&&
		m_pEnemyFinalHillAttack7.GetUnitsCount()==0
		&&
		m_pEnemyFinalHillAttack8.GetUnitsCount()==0)
    {
		return Victory;
    }
	//if (m_pEnemyTruck.DistanceTo(GetPointX(17), GetPointY(17))<3) return MissionFailed3;

	return DestroyTruck;
}//|
state Victory
{

		//SetGoalState(gDestroyTruck,goalAchieved);
		SetGoalState(gDefenceStartPosition,goalAchieved);

    AddBriefing(SND_R23_BRIEFING_VICTORY, TRL_R23_BRIEFING_VICTORY);
    //m_pPlayer.SaveUnit(0, false, m_hHero);
    //next mission:
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(0), GetPointY(0), 0);
    EndMission(true);
    return Victory, 200;
}//|

state MissionFailed
{

    AddBriefing(SND_R23_BRIEFING_HERO_DEAD, TRL_R23_BRIEFING_HERO_DEAD);
    EndMission(false);
    return MissionFailed, 200;
}//|

state MissionFailed2
{
	AddBriefing(SND_R23_BRIEFING_LOSTPOSITION, TRL_R23_BRIEFING_LOSTPOSITION);

    EndMission(false);
//utrata plutonu
    return MissionFailed2, 200;
}//|

state MissionFailed3
{
	AddBriefing(SND_R23_BRIEFING_SUKCESTRUCK, TRL_R23_BRIEFING_SUKCESTRUCK);
    EndMission(false);
//utrata plutonu
    return MissionFailed3, 200;
}//|
state MissionFailed4	
{
	AddBriefing(SND_R23_BRIEFING_LOSTRECON, TRL_R23_BRIEFING_LOSTRECON);

    EndMission(false);
//utrata plutonu
    return MissionFailed2, 200;
}//|
command Uninitialize()
{
	m_pEnemyHillAttack1 = null;
	m_pEnemyHillAttack2 = null;
	m_pEnemyHillAttack3 = null;
	m_pEnemyFinalHillAttack1 = null;
	m_pEnemyFinalHillAttack2 = null;
	m_pEnemyFinalHillAttack3 = null;
	m_pEnemyFinalHillAttack4 = null;
	m_pEnemyFinalHillAttack5 = null;
	m_pEnemyFinalHillAttack6 = null;
	m_pEnemyFinalHillAttack7 = null;
	m_pEnemyFinalHillAttack8 = null;
    m_pPlayer2Recon = null;
    m_pEnemyTruck = null;
    m_hHero = null;
    return true;
}//|


event Timer0()
{
    if (m_bTimerSetConsole)
    {
        --m_nTimerSetConsole;
        if (m_nTimerSetConsole == 0)
        {
            SetConsoleText(1, ""); 
            SetConsoleText(2, ""); 
            SetConsoleText(3, "");
            m_bTimerSetConsole = false;
        }
    }
}//|
	event Timer2()
    {
        CheckSupplyLive();
    }

event Timer1()
{
/*    if (!CheckHeroLive())
    {
        state MissionFailed;
    }*/

    if (!CheckUnitsCount())
    {
        state MissionFailed;
    }

 
    if (m_bDefenceposition1 &&
		(
        (IsUnitNearPoint(GetPointX(30), GetPointY(30), 0, 5, m_pEnemy.GetIFF()) &&
		!IsUnitNearPoint(GetPointX(30), GetPointY(30), 0, 5, m_pPlayer.GetIFF()))
		|| 
        (IsUnitNearPoint(GetPointX(31), GetPointY(31), 0, 5, m_pEnemy.GetIFF()) &&
        !IsUnitNearPoint(GetPointX(31), GetPointY(31), 0, 5, m_pPlayer.GetIFF()))
		||
        (IsUnitNearPoint(GetPointX(33), GetPointY(33), 0, 5, m_pEnemy.GetIFF()) &&
        !IsUnitNearPoint(GetPointX(33), GetPointY(33), 0, 5, m_pPlayer.GetIFF()))
		||
        (IsUnitNearPoint(GetPointX(32), GetPointY(32), 0, 5, m_pEnemy.GetIFF()) &&
        !IsUnitNearPoint(GetPointX(32), GetPointY(32), 0, 5, m_pPlayer.GetIFF()))
		)
	  )
    {
        state MissionFailed2;
    }
    /*if (!EnemyPosition1 &&
	    !IsUnitNearPoint(GetPointX(34), GetPointY(34), 0, 8, m_pEnemy.GetIFF()) && 
		IsUnitNearPoint(GetPointX(34), GetPointY(34), 0, 5, m_pPlayer.GetIFF()))
	{
        RemoveArtefact(GetPointX(34), GetPointY(34), 0);
        CreateArtefact("ART_ZNAKRUS", GetPointX(34), GetPointY(34), 0, aEnemyPositionRUS1, artefactSpecialAI);

        SetConsoleText(1, "");
        SetConsoleText(2, "");
        SetConsoleText(3, "");
        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;

        EnemyPosition1 = true;
	}
    if (!EnemyPosition2 &&
	    !IsUnitNearPoint(GetPointX(35), GetPointY(35), 0, 8, m_pEnemy.GetIFF()) && 
		IsUnitNearPoint(GetPointX(35), GetPointY(35), 0, 5, m_pPlayer.GetIFF()))
	{
        RemoveArtefact(GetPointX(35), GetPointY(35), 0);
        CreateArtefact("ART_ZNAKRUS", GetPointX(35), GetPointY(35), 0, aEnemyPositionRUS2, artefactSpecialAI);

        SetConsoleText(1, "");
        SetConsoleText(2, "");
        SetConsoleText(3, "");
        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;

        EnemyPosition2 = true;
	}
    if (!EnemyPosition3 &&
	    !IsUnitNearPoint(GetPointX(36), GetPointY(36), 0, 8, m_pEnemy.GetIFF()) && 
		IsUnitNearPoint(GetPointX(36), GetPointY(36), 0, 5, m_pPlayer.GetIFF()))
	{
        RemoveArtefact(GetPointX(36), GetPointY(36), 0);
        CreateArtefact("ART_ZNAKRUS", GetPointX(36), GetPointY(36), 0, aEnemyPositionRUS3, artefactSpecialAI);

        SetConsoleText(1, "");
        SetConsoleText(2, "");
        SetConsoleText(3, "");
        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;

        EnemyPosition3 = true;
	}
    if (!EnemyPosition4 &&
	    !IsUnitNearPoint(GetPointX(37), GetPointY(37), 0, 8, m_pEnemy.GetIFF()) && 
		IsUnitNearPoint(GetPointX(37), GetPointY(37), 0, 5, m_pPlayer.GetIFF()))
	{
        RemoveArtefact(GetPointX(37), GetPointY(37), 0);
        CreateArtefact("ART_ZNAKRUS", GetPointX(37), GetPointY(37), 0, aEnemyPositionRUS4, artefactSpecialAI);

        SetConsoleText(1, "");
        SetConsoleText(2, "");
        SetConsoleText(3, "");
        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;

        EnemyPosition4 = true;
	}
    if (!EnemyPosition5 &&
	    !IsUnitNearPoint(GetPointX(38), GetPointY(38), 0, 8, m_pEnemy.GetIFF()) && 
		IsUnitNearPoint(GetPointX(38), GetPointY(38), 0, 5, m_pPlayer.GetIFF()))
	{
        RemoveArtefact(GetPointX(38), GetPointY(38), 0);
        CreateArtefact("ART_ZNAKRUS", GetPointX(38), GetPointY(38), 0, aEnemyPositionRUS5, artefactSpecialAI);

        SetConsoleText(1, "");
        SetConsoleText(2, "");
        SetConsoleText(3, "");
        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;

        EnemyPosition5 = true;
	}*/

}
}

